      SUBROUTINE DPCHIC(IC, VC, SWITCH, N, X,F,D,INCFD, WK, NWK, IERR)
C
C-----------------------------------------------------------------------
C
C         DPCHIC:  PIECEWISE CUBIC HERMITE INTERPOLATION COEFFICIENTS.
C
C    SETS DERIVATIVES NEEDED TO DETERMINE A PIECEWISE MONOTONE PIECE-
C    WISE CUBIC INTERPOLANT TO THE DATA GIVEN IN X AND F SATISFYING THE
C    BOUNDARY CONDITIONS SPECIFIED BY IC AND VC.
C
C    THE TREATMENT OF POINTS WHERE MONOTONICITY SWITCHES DIRECTION IS
C    CONTROLLED BY ARGUMENT SWITCH.
C
C    TO FACILITATE TWO-DIMENSIONAL APPLICATIONS, INCLUDES AN INCREMENT
C    BETWEEN SUCCESSIVE VALUES OF THE F- AND D-ARRAYS.
C
C    THE RESULTING PIECEWISE CUBIC HERMITE FUNCTION MAY BE EVALUATED
C    BY DPCHFE OR PCHFD.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C        CALL DPCHIC(IC, VC, SWITCH, N, X, F, D, INCFD, WK, NWK, IERR)
C
      INTEGER  IC(2), N, INCFD, NWK, IERR
      DOUBLE PRECISION  VC(2),SWITCH,X(N),F(INCFD,N),D(INCFD,N),WK(NWK)
C
C   PARAMETERS:
C
C     IC -- (INPUT) INTEGER ARRAY OF LENGTH 2 SPECIFYING DESIRED
C           BOUNDARY CONDITIONS:
C           IC(1) = IBEG, DESIRED CONDITION AT BEGINNING OF DATA.
C           IC(2) = IEND, DESIRED CONDITION AT END OF DATA.
C
C           IBEG = 0  FOR THE DEFAULT BOUNDARY CONDITION (THE SAME AS
C                     USED BY DPCHIM).
C           IF IBEG.NE.0, THEN ITS SIGN INDICATES WHETHER THE BOUNDARY
C                     DERIVATIVE IS TO BE ADJUSTED, IF NECESSARY, TO BE
C                     COMPATIBLE WITH MONOTONICITY:
C              IBEG.GT.0  IF NO ADJUSTMENT IS TO BE PERFORMED.
C              IBEG.LT.0  IF THE DERIVATIVE IS TO BE ADJUSTED FOR
C                     MONOTONICITY.
C
C           ALLOWABLE VALUES FOR THE MAGNITUDE OF IBEG ARE:
C           IBEG = 1  IF FIRST DERIVATIVE AT X(1) IS GIVEN IN VC(1).
C           IBEG = 2  IF SECOND DERIVATIVE AT X(1) IS GIVEN IN VC(1).
C           IBEG = 3  TO USE THE 3-POINT DIFFERENCE FORMULA FOR D(1).
C                     (REVERTS TO THE DEFAULT B.C. IF N.LT.3 .)
C           IBEG = 4  TO USE THE 4-POINT DIFFERENCE FORMULA FOR D(1).
C                     (REVERTS TO THE DEFAULT B.C. IF N.LT.4 .)
C           IBEG = 5  TO SET D(1) SO THAT THE SECOND DERIVATIVE IS CON-
C              TINUOUS AT X(2). (REVERTS TO THE DEFAULT B.C. IF N.LT.4.)
C              THIS OPTION IS SOMEWHAT ANALOGOUS TO THE "NOT A KNOT"
C              BOUNDARY CONDITION PROVIDED BY DPCHSP.
C
C          NOTES (IBEG):
C           1. AN ERROR RETURN IS TAKEN IF DABS(IBEG).GT.5 .
C           2. ONLY IN CASE  IBEG.LE.0  IS IT GUARANTEED THAT THE
C              INTERPOLANT WILL BE MONOTONIC IN THE FIRST INTERVAL.
C              IF THE RETURNED VALUE OF D(1) LIES BETWEEN ZERO AND
C              3*SLOPE(1), THE INTERPOLANT WILL BE MONOTONIC.  THIS
C              IS **NOT** CHECKED IF IBEG.GT.0 .
C           3. IF IBEG.LT.0 AND D(1) HAD TO BE CHANGED TO ACHIEVE MONO-
C              TONICITY, A WARNING ERROR IS RETURNED.
C
C           IEND MAY TAKE ON THE SAME VALUES AS IBEG, BUT APPLIED TO
C           DERIVATIVE AT X(N).  IN CASE IEND = 1 OR 2, THE VALUE IS
C           GIVEN IN VC(2).
C
C          NOTES (IEND):
C           1. AN ERROR RETURN IS TAKEN IF DABS(IEND).GT.5 .
C           2. ONLY IN CASE  IEND.LE.0  IS IT GUARANTEED THAT THE
C              INTERPOLANT WILL BE MONOTONIC IN THE LAST INTERVAL.
C              IF THE RETURNED VALUE OF D(1+(N-1)*INCFD) LIES BETWEEN
C              ZERO AND 3*SLOPE(N-1), THE INTERPOLANT WILL BE MONOTONIC.
C              THIS IS **NOT** CHECKED IF IEND.GT.0 .
C           3. IF IEND.LT.0 AND D(1+(N-1)*INCFD) HAD TO BE CHANGED TO
C              ACHIEVE MONOTONICITY, A WARNING ERROR IS RETURNED.
C
C     VC -- (INPUT) REAL ARRAY OF LENGTH 2 SPECIFYING DESIRED BOUNDARY
C           VALUES, AS INDICATED ABOVE.
C           VC(1) NEED BE SET ONLY IF IC(1) = 1 OR 2 .
C           VC(2) NEED BE SET ONLY IF IC(2) = 1 OR 2 .
C
C     SWITCH -- (INPUT) INDICATES DESIRED TREATMENT OF POINTS WHERE
C           DIRECTION OF MONOTONICITY SWITCHES:
C           SET SWITCH TO ZERO IF THE INTERPOLANT IS REQUIRED TO BE
C              MONOTONIC IN EACH INTERVAL, REGARDLESS OF MONOTONICITY
C              OF DATA.
C             NOTES:
C              1. THIS WILL CAUSE D TO BE SET TO ZERO AT ALL SWITCH
C                 POINTS, THUS FORCING EXTREMA THERE.
C              2. THE RESULT OF USING THIS OPTION WITH THE DEFAULT BOUN-
C                 DARY CONDITIONS WILL BE IDENTICAL TO USING DPCHIM, BUT
C                 WILL GENERALLY COST MORE COMPUTE TIME.
C                 THIS OPTION IS PROVIDED ONLY TO FACILITATE COMPARISON
C                 OF DIFFERENT SWITCH AND/OR BOUNDARY CONDITIONS.
C           SET SWITCH NONZERO TO USE A FORMULA BASED ON THE 3-POINT
C              DIFFERENCE FORMULA IN THE VICINITY OF SWITCH POINTS.
C           IF SWITCH IS POSITIVE, THE INTERPOLANT ON EACH INTERVAL
C              CONTAINING AN EXTREMUM IS CONTROLLED TO NOT DEVIATE FROM
C              THE DATA BY MORE THAN SWITCH*DFLOC, WHERE DFLOC IS THE
C              MAXIMUM OF THE CHANGE OF F ON THIS INTERVAL AND ITS TWO
C              IMMEDIATE NEIGHBORS.
C           IF SWITCH IS NEGATIVE, NO SUCH CONTROL IS TO BE IMPOSED.
C
C     N -- (INPUT) NUMBER OF DATA POINTS.  (ERROR RETURN IF N.LT.2 .)
C
C     X -- (INPUT) REAL ARRAY OF INDEPENDENT VARIABLE VALUES.  THE
C           ELEMENTS OF X MUST BE STRICTLY INCREASING:
C                X(I-1) .LT. X(I),  I = 2(1)N.
C           (ERROR RETURN IF NOT.)
C
C     F -- (INPUT) REAL ARRAY OF DEPENDENT VARIABLE VALUES TO BE INTER-
C           POLATED.  F(1+(I-1)*INCFD) IS VALUE CORRESPONDING TO X(I).
C
C     D -- (OUTPUT) REAL ARRAY OF DERIVATIVE VALUES AT THE DATA POINTS.
C           THESE VALUES WILL DETERMINE A MONOTONE CUBIC HERMITE FUNC-
C           TION ON EACH SUBINTERVAL ON WHICH THE DATA ARE MONOTONIC,
C           EXCEPT POSSIBLY ADJACENT TO SWITCHES IN MONOTONICITY.
C           THE VALUE CORRESPONDING TO X(I) IS STORED IN
C                D(1+(I-1)*INCFD),  I=1(1)N.
C           NO OTHER ENTRIES IN D ARE CHANGED.
C
C     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN F AND D.
C           THIS ARGUMENT IS PROVIDED PRIMARILY FOR 2-D APPLICATIONS.
C           (ERROR RETURN IF  INCFD.LT.1 .)
C
C     WK -- (OUTPUT) REAL ARRAY OF WORKING STORAGE.  RETURNED VALUES:
C              WK(I)     = H(I)     = X(I+1) - X(I) ;
C              WK(N-1+I) = SLOPE(I) = (F(1,I+1) - F(1,I)) / H(I)
C           FOR  I = 1(1)N-1.
C
C     NWK -- (INPUT) LENGTH OF WORK ARRAY.
C           (ERROR RETURN IF  NWK.LT.2*(N-1) .)
C
C     IERR -- (OUTPUT) ERROR FLAG.
C           NORMAL RETURN:
C              IERR = 0  (NO ERRORS).
C           WARNING ERRORS:
C              IERR = 1  IF IBEG.LT.0 AND D(1) HAD TO BE ADJUSTED FOR
C                        MONOTONICITY.
C              IERR = 2  IF IEND.LT.0 AND D(1+(N-1)*INCFD) HAD TO BE
C                        ADJUSTED FOR MONOTONICITY.
C              IERR = 3  IF BOTH OF THE ABOVE ARE TRUE.
C           "RECOVERABLE" ERRORS:
C              IERR = -1  IF N.LT.2 .
C              IERR = -2  IF INCFD.LT.1 .
C              IERR = -3  IF THE X-ARRAY IS NOT STRICTLY INCREASING.
C              IERR = -4  IF IABS(IBEG).GT.5 .
C              IERR = -5  IF IABS(IEND).GT.5 .
C              IERR = -6  IF BOTH OF THE ABOVE ARE TRUE.
C              IERR = -7  IF NWK.LT.2*(N-1) .
C             (THE D-ARRAY HAS NOT BEEN CHANGED IN ANY OF THESE CASES.)
C               NOTE:  THE ABOVE ERRORS ARE CHECKED IN THE ORDER LISTED,
C                   AND FOLLOWING ARGUMENTS HAVE **NOT** BEEN VALIDATED.
C
C  FORTRAN INTRINSICS USED:  IABS.
C  OTHER ROUTINES USED:  DPCHCE, DPCHCI, DPCHCS.
C
C-----------------------------------------------------------------------
C
C  REFERENCES:  1. F.N.FRITSCH AND R.E.CARLSON, "MONOTONE PIECEWISE
C                 CUBIC INTERPOLATION," SIAM J.NUMER.ANAL. 17, 2 (APRIL
C                 1980), 238-246.
C               2. F.N.FRITSCH AND J.BUTLAND, "A METHOD FOR CONSTRUCTING
C                 LOCAL MONOTONE PIECEWISE CUBIC INTERPOLANTS," LLNL
C                 PREPRINT UCRL-87559 (APRIL 1982).
C               3. F.N.FRITSCH, "PIECEWISE CUBIC INTERPOLATION PACKAGE,"
C                 LLNL PREPRINT UCRL-87285 (JULY 1982).
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-03   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHIC TO DPCHIC WHEREVER IT OCCURS,
C        B. CHANGE DPCHCE TO DPCHCE WHEREVER IT OCCURS,
C        C. CHANGE PCHCI TO DPCHCI WHEREVER IT OCCURS,
C        D. CHANGE PCHCS TO DPCHCS WHEREVER IT OCCURS,
C        E. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION, AND
C        F. CHANGE THE CONSTANT  ZERO  TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I, IBEG, IEND, NLESS1
      DOUBLE PRECISION  ZERO
      DATA  ZERO /0.0D0/
C
C  VALIDITY-CHECK ARGUMENTS.
C
      IF ( N.LT.2 )  GO TO 5001
      IF ( INCFD.LT.1 )  GO TO 5002
      DO 1  I = 2, N
         IF ( X(I).LE.X(I-1) )  GO TO 5003
    1 CONTINUE
C
      IBEG = IC(1)
      IEND = IC(2)
      IERR = 0
      IF (IABS(IBEG) .GT. 5)  IERR = IERR - 1
      IF (IABS(IEND) .GT. 5)  IERR = IERR - 2
      IF (IERR .LT. 0)  GO TO 5004
C
C  FUNCTION DEFINITION IS OK; GO ON.
C
      NLESS1 = N - 1
      IF ( NWK .LT. 2*NLESS1 )  GO TO 5007
C
C  SET UP H AND SLOPE ARRAYS.
C
      DO 20  I = 1, NLESS1
         WK(I) = X(I+1) - X(I)
         WK(NLESS1+I) = (F(1,I+1) - F(1,I)) / WK(I)
   20 CONTINUE
C
C  SPECIAL CASE N=2 -- USE LINEAR INTERPOLATION.
C
      IF (NLESS1 .GT. 1)  GO TO 1000
      D(1,1) = WK(2)
      D(1,N) = WK(2)
      GO TO 3000
C
C  NORMAL CASE  (N .GE. 3) .
C
 1000 CONTINUE
C
C  SET INTERIOR DERIVATIVES AND DEFAULT END CONDITIONS.
C
C     --------------------------------------
      CALL DPCHCI (N, WK(1), WK(N), D, INCFD)
C     --------------------------------------
C
C  SET DERIVATIVES AT POINTS WHERE MONOTONICITY SWITCHES DIRECTION.
C
      IF (SWITCH .EQ. ZERO)  GO TO 3000
C     ----------------------------------------------------
      CALL DPCHCS (SWITCH, N, WK(1), WK(N), D, INCFD, IERR)
C     ----------------------------------------------------
      IF (IERR .NE. 0)  GO TO 5008
C
C  SET END CONDITIONS.
C
 3000 CONTINUE
      IF ( (IBEG.EQ.0) .AND. (IEND.EQ.0) )  GO TO 5000
C     -------------------------------------------------------
      CALL DPCHCE (IC, VC, N, X, WK(1), WK(N), D, INCFD, IERR)
C     -------------------------------------------------------
      IF (IERR .LT. 0)  GO TO 5009
C
C  NORMAL RETURN.
C
 5000 CONTINUE
      RETURN
C
C  ERROR RETURNS.
C
 5001 CONTINUE
C     N.LT.2 RETURN.
      IERR = -1
      RETURN
C
 5002 CONTINUE
C     INCFD.LT.1 RETURN.
      IERR = -2
      RETURN
C
 5003 CONTINUE
C     X-ARRAY NOT STRICTLY INCREASING.
      IERR = -3
      RETURN
C
 5004 CONTINUE
C     IC OUT OF RANGE RETURN.
      IERR = IERR - 3
      RETURN
C
 5007 CONTINUE
C     NWK .LT. 2*(N-1)  RETURN.
      IERR = -7
      RETURN
C
 5008 CONTINUE
C     ERROR RETURN FROM DPCHCS.
      IERR = -8
      RETURN
C
 5009 CONTINUE
C     ERROR RETURN FROM DPCHCE.
C   *** THIS CASE SHOULD NEVER OCCUR ***
      IERR = -9
      RETURN
C------------- LAST LINE OF DPCHIC FOLLOWS -----------------------------
      END
      SUBROUTINE DPCHCE (IC, VC, N, X, H, SLOPE, D, INCFD, IERR)
C
C-----------------------------------------------------------------------
C
C          DPCHCE:  DPCHIC END DERIVATIVE SETTER.
C
C    CALLED BY DPCHIC TO SET END DERIVATIVES AS REQUESTED BY THE USER.
C    IT MUST BE CALLED AFTER INTERIOR DERIVATIVE VALUES HAVE BEEN SET.
C                      -----
C
C    TO FACILITATE TWO-DIMENSIONAL APPLICATIONS, INCLUDES AN INCREMENT
C    BETWEEN SUCCESSIVE VALUES OF THE D-ARRAY.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           CALL  PCHCE (IC, VC, N, X, H, SLOPE, D, INCFD, IERR)
C
      INTEGER  IC(2), N, INCFD, IERR
      DOUBLE PRECISION  VC(2), X(N), H(N), SLOPE(N), D(INCFD,N)
C
C   PARAMETERS:
C
C     IC -- (INPUT) INTEGER ARRAY OF LENGTH 2 SPECIFYING DESIRED
C           BOUNDARY CONDITIONS:
C           IC(1) = IBEG, DESIRED CONDITION AT BEGINNING OF DATA.
C           IC(2) = IEND, DESIRED CONDITION AT END OF DATA.
C           ( SEE PROLOGUE TO DPCHIC FOR DETAILS. )
C
C     VC -- (INPUT) REAL ARRAY OF LENGTH 2 SPECIFYING DESIRED BOUNDARY
C           VALUES.  VC(1) NEED BE SET ONLY IF IC(1) = 2 OR 3 .
C                    VC(2) NEED BE SET ONLY IF IC(2) = 2 OR 3 .
C
C     N -- (INPUT) NUMBER OF DATA POINTS.  (ASSUMES N.GE.2)
C
C     X -- (INPUT) REAL ARRAY OF INDEPENDENT VARIABLE VALUES.  (THE
C           ELEMENTS OF X ARE ASSUMED TO BE STRICTLY INCREASING.)
C
C     H -- (INPUT) REAL ARRAY OF INTERVAL LENGTHS.
C     SLOPE -- (INPUT) REAL ARRAY OF DATA SLOPES.
C           IF THE DATA ARE (X(I),Y(I)), I=1(1)N, THEN THESE INPUTS ARE:
C                  H(I) =  X(I+1)-X(I),
C              SLOPE(I) = (Y(I+1)-Y(I))/H(I),  I=1(1)N-1.
C
C     D -- (INPUT) REAL ARRAY OF DERIVATIVE VALUES AT THE DATA POINTS.
C           THE VALUE CORRESPONDING TO X(I) MUST BE STORED IN
C                D(1+(I-1)*INCFD),  I=1(1)N.
C          (OUTPUT) THE VALUE OF D AT X(1) AND/OR X(N) IS CHANGED, IF
C           NECESSARY, TO PRODUCE THE REQUESTED BOUNDARY CONDITIONS.
C           NO OTHER ENTRIES IN D ARE CHANGED.
C
C     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN D.
C           THIS ARGUMENT IS PROVIDED PRIMARILY FOR 2-D APPLICATIONS.
C
C     IERR -- (OUTPUT) ERROR FLAG.
C           NORMAL RETURN:
C              IERR = 0  (NO ERRORS).
C           WARNING ERRORS:
C              IERR = 1  IF IBEG.LT.0 AND D(1) HAD TO BE ADJUSTED FOR
C                        MONOTONICITY.
C              IERR = 2  IF IEND.LT.0 AND D(1+(N-1)*INCFD) HAD TO BE
C                        ADJUSTED FOR MONOTONICITY.
C              IERR = 3  IF BOTH OF THE ABOVE ARE TRUE.
C
C    -------
C    WARNING:  THIS ROUTINE DOES NO VALIDITY-CHECKING OF ARGUMENTS.
C    -------
C
C  FORTRAN INTRINSICS USED:  DABS, IABS.
C  OTHER ROUTINES USED:  DPCHDF, DPCHST.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-04   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     1. THE FUNCTION  DPCHST(ARG1,ARG2)  IS ASSUMED TO RETURN ZERO IF
C        EITHER ARGUMENT IS ZERO, +1 IF THEY ARE OF THE SAME SIGN, AND
C        -1 IF THEY ARE OF OPPOSITE SIGN.
C     2. TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE DPCHCE TO DPCHCE WHEREVER IT OCCURS,
C        B. CHANGE
C        C. CHANGE PCHST TO DPCHST WHEREVER IT OCCURS,
C        D. CHANGE ALL REFERENCES TO THE FORTRAN INTRINSICS TO THEIR
C           DOUBLE PRESISION EQUIVALENTS,
C        E. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION, AND
C        F. CHANGE THE CONSTANTS ZERO, HALF, ... TO DOUBLE PRECISION.
C     3. ONE COULD REDUCE THE NUMBER OF ARGUMENTS AND AMOUNT OF LOCAL
C        STORAGE, AT THE EXPENSE OF REDUCED CODE CLARITY, BY PASSING IN
C        THE ARRAY WK (RATHER THAN SPLITTING IT INTO H AND SLOPE) AND
C        INCREASING ITS LENGTH ENOUGH TO INCORPORATE STEMP AND XTEMP.
C     4. THE TWO MONOTONICITY CHECKS ONLY USE THE SUFFICIENT CONDITIONS.
C        THUS, IT IS POSSIBLE (BUT UNLIKELY) FOR A BOUNDARY CONDITION TO
C        BE CHANGED, EVEN THOUGH THE ORIGINAL INTERPOLANT WAS MONOTONIC.
C        (AT LEAST THE RESULT IS A CONTINUOUS FUNCTION OF THE DATA.)
C
C-----------------------------------------------------------------------
C
C  DELCARE LOCAL VARIABLES.
C
      INTEGER  IBEG, IEND, IERF, INDEX, J, K
      DOUBLE PRECISION  HALF, STEMP(3), THREE, TWO, XTEMP(4), ZERO
      DOUBLE PRECISION  DPCHDF, DPCHST
C
C  INITIALIZE.
C
      DATA  ZERO /0.0D0/,  HALF /0.5D0/,  TWO /2.0D0/,  THREE /3.0D0/
C
      IBEG = IC(1)
      IEND = IC(2)
      IERR = 0
C
C  SET TO DEFAULT BOUNDARY CONDITIONS IF N IS TOO SMALL.
C
      IF ( IABS(IBEG).GT.N )  IBEG = 0
      IF ( IABS(IEND).GT.N )  IEND = 0
C
C  TREAT BEGINNING BOUNDARY CONDITION.
C
      IF (IBEG .EQ. 0)  GO TO 2000
      K = IABS(IBEG)
      IF (K .EQ. 1)  THEN
C        BOUNDARY VALUE PROVIDED.
         D(1,1) = VC(1)
      ELSE IF (K .EQ. 2)  THEN
C        BOUNDARY SECOND DERIVATIVE PROVIDED.
         D(1,1) = HALF*( (THREE*SLOPE(1) - D(1,2)) - HALF*VC(1)*H(1) )
      ELSE IF (K .LT. 5)  THEN
C        USE K-POINT DERIVATIVE FORMULA.
C        PICK UP FIRST K POINTS, IN REVERSE ORDER.
         DO 10  J = 1, K
            INDEX = K-J+1
C           INDEX RUNS FROM K DOWN TO 1.
            XTEMP(J) = X(INDEX)
            IF (J .LT. K)  STEMP(J) = SLOPE(INDEX-1)
   10    CONTINUE
C                 -----------------------------
         D(1,1) = DPCHDF (K, XTEMP, STEMP, IERF)
C                 -----------------------------
         IF (IERF .NE. 0)  GO TO 5001
      ELSE
C        USE "NOT A KNOT" CONDITION.
         D(1,1) = ( THREE*(H(1)*SLOPE(2) + H(2)*SLOPE(1))
     *             - TWO*(H(1)+H(2))*D(1,2) - H(1)*D(1,3) ) / H(2)
      ENDIF
C
      IF (IBEG .GT. 0)  GO TO 2000
C
C  CHECK D(1,1) FOR COMPATIBILITY WITH MONOTONICITY.
C
      IF (SLOPE(1) .EQ. ZERO)  THEN
         IF (D(1,1) .NE. ZERO)  THEN
            D(1,1) = ZERO
            IERR = IERR + 1
         ENDIF
      ELSE IF ( DPCHST(D(1,1),SLOPE(1)) .LT. ZERO)  THEN
         D(1,1) = ZERO
         IERR = IERR + 1
      ELSE IF ( DABS(D(1,1)) .GT. THREE*DABS(SLOPE(1)) )  THEN
         D(1,1) = THREE*SLOPE(1)
         IERR = IERR + 1
      ENDIF
C
C  TREAT END BOUNDARY CONDITION.
C
 2000 CONTINUE
      IF (IEND .EQ. 0)  GO TO 5000
      K = IABS(IEND)
      IF (K .EQ. 1)  THEN
C        BOUNDARY VALUE PROVIDED.
         D(1,N) = VC(2)
      ELSE IF (K .EQ. 2)  THEN
C        BOUNDARY SECOND DERIVATIVE PROVIDED.
         D(1,N) = HALF*( (THREE*SLOPE(N-1) - D(1,N-1)) +
     *                                           HALF*VC(2)*H(N-1) )
      ELSE IF (K .LT. 5)  THEN
C        USE K-POINT DERIVATIVE FORMULA.
C        PICK UP LAST K POINTS.
         DO 2010  J = 1, K
            INDEX = N-K+J
C           INDEX RUNS FROM N+1-K UP TO N.
            XTEMP(J) = X(INDEX)
            IF (J .LT. K)  STEMP(J) = SLOPE(INDEX)
 2010    CONTINUE
C                 -----------------------------
         D(1,N) = DPCHDF (K, XTEMP, STEMP, IERF)
C                 -----------------------------
         IF (IERF .NE. 0)  GO TO 5001
      ELSE
C        USE "NOT A KNOT" CONDITION.
         D(1,N) = ( THREE*(H(N-1)*SLOPE(N-2) + H(N-2)*SLOPE(N-1))
     *             - TWO*(H(N-1)+H(N-2))*D(1,N-1) - H(N-1)*D(1,N-2) )
     *                                                         / H(N-2)
      ENDIF
C
      IF (IEND .GT. 0)  GO TO 5000
C
C  CHECK D(1,N) FOR COMPATIBILITY WITH MONOTONICITY.
C
      IF (SLOPE(N-1) .EQ. ZERO)  THEN
         IF (D(1,N) .NE. ZERO)  THEN
            D(1,N) = ZERO
            IERR = IERR + 2
         ENDIF
      ELSE IF ( DPCHST(D(1,N),SLOPE(N-1)) .LT. ZERO)  THEN
         D(1,N) = ZERO
         IERR = IERR + 2
      ELSE IF ( DABS(D(1,N)) .GT. THREE*DABS(SLOPE(N-1)) )  THEN
         D(1,N) = THREE*SLOPE(N-1)
         IERR = IERR + 2
      ENDIF
C
C  NORMAL RETURN.
C
 5000 CONTINUE
      RETURN
C
C  ERROR RETURN.
C
 5001 CONTINUE
C     ERROR RETURN FROM DPCHDF.
C   *** THIS CASE SHOULD NEVER OCCUR ***
      IERR = -1
      RETURN
C------------- LAST LINE OF PCHCE FOLLOWS ------------------------------
      END
      SUBROUTINE DPCHCI (N, H, SLOPE, D, INCFD)
C
C-----------------------------------------------------------------------
C
C          DPCHCI:  DPCHIC INITIAL DERIVATIVE SETTER.
C
C    CALLED BY DPCHIC TO SET DERIVATIVES NEEDED TO DETERMINE A MONOTONE
C    PIECEWISE CUBIC HERMITE INTERPOLANT TO THE DATA.
C
C    DEFAULT BOUNDARY CONDITIONS ARE PROVIDED WHICH ARE COMPATIBLE
C    WITH MONOTONICITY.  IF THE DATA ARE ONLY PIECEWISE MONOTONIC, THE
C    INTERPOLANT WILL HAVE AN EXTREMUM AT EACH POINT WHERE MONOTONICITY
C    SWITCHES DIRECTION.
C
C    TO FACILITATE TWO-DIMENSIONAL APPLICATIONS, INCLUDES AN INCREMENT
C    BETWEEN SUCCESSIVE VALUES OF THE D-ARRAY.
C
C    THE RESULTING PIECEWISE CUBIC HERMITE FUNCTION SHOULD BE IDENTICAL
C    (WITHIN ROUNDOFF ERROR) TO THAT PRODUCED BY DPCHIM.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           CALL  DPCHCI (N, H, SLOPE, D, INCFD)
C
      INTEGER  N, INCFD
      DOUBLE PRECISION  H(N), SLOPE(N), D(INCFD,N)
C
C   PARAMETERS:
C
C     N -- (INPUT) NUMBER OF DATA POINTS.
C           IF N=2, SIMPLY DOES LINEAR INTERPOLATION.
C
C     H -- (INPUT) REAL ARRAY OF INTERVAL LENGTHS.
C     SLOPE -- (INPUT) REAL ARRAY OF DATA SLOPES.
C           IF THE DATA ARE (X(I),Y(I)), I=1(1)N, THEN THESE INPUTS ARE:
C                  H(I) =  X(I+1)-X(I),
C              SLOPE(I) = (Y(I+1)-Y(I))/H(I),  I=1(1)N-1.
C
C     D -- (OUTPUT) REAL ARRAY OF DERIVATIVE VALUES AT THE DATA POINTS.
C           IF THE DATA ARE MONOTONIC, THESE VALUES WILL DETERMINE A
C           A MONOTONE CUBIC HERMITE FUNCTION.
C           THE VALUE CORRESPONDING TO X(I) IS STORED IN
C                D(1+(I-1)*INCFD),  I=1(1)N.
C           NO OTHER ENTRIES IN D ARE CHANGED.
C
C     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN D.
C           THIS ARGUMENT IS PROVIDED PRIMARILY FOR 2-D APPLICATIONS.
C
C    -------
C    WARNING:  THIS ROUTINE DOES NO VALIDITY-CHECKING OF ARGUMENTS.
C    -------
C
C  FORTRAN INTRINSICS USED:  DABS, DMAX1, DMIN1.
C  OTHER ROUTINES USED:  DPCHST.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-06-01   MODIFIED END CONDITIONS TO BE CONTINUOUS FUNCTIONS OF
C                DATA WHEN MONOTONICITY SWITCHES IN NEXT INTERVAL.
C     82-06-02   1. MODIFIED FORMULAS SO END CONDITIONS ARE LESS PRONE
C                   TO OVER/UNDERFLOW PROBLEMS.
C                2. MINOR MODIFICATION TO HSUM CALCULATION.
C     82-08-04   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     1. THE FUNCTION  DPCHST(ARG1,ARG2)  IS ASSUMED TO RETURN ZERO IF
C        EITHER ARGUMENT IS ZERO, +1 IF THEY ARE OF THE SAME SIGN, AND
C        -1 IF THEY ARE OF OPPOSITE SIGN.
C     2. TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHCI TO DPCHCI WHEREVER IT OCCURS,
C        B. CHANGE PCHST TO DPCHST WHEREVER IT OCCURS,
C        C. CHANGE ALL REFERENCES TO THE FORTRAN INTRINSICS TO THEIR
C           DOUBLE PRESISION EQUIVALENTS,
C        D. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION, AND
C        E. CHANGE THE CONSTANTS ZERO AND THREE TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIBLES.
C
      INTEGER  I, NLESS1
      DOUBLE PRECISION  DEL1,DEL2,DMAX,DMIN,DRAT1,DRAT2,HSUM,HSUMT3,
     *    THREE, W1, W2, ZERO
      DOUBLE PRECISION  DPCHST
C
C  INITIALIZE.
C
      DATA  ZERO /0.0D0/,  THREE /3.0D0/
      NLESS1 = N - 1
      DEL1 = SLOPE(1)
C
C  SPECIAL CASE N=2 -- USE LINEAR INTERPOLATION.
C
      IF (NLESS1 .GT. 1)  GO TO 10
      D(1,1) = DEL1
      D(1,N) = DEL1
      GO TO 5000
C
C  NORMAL CASE  (N .GE. 3).
C
   10 CONTINUE
      DEL2 = SLOPE(2)
C
C  SET D(1) VIA NON-CENTERED THREE-POINT FORMULA, ADJUSTED TO BE
C     SHAPE-PRESERVING.
C
      HSUM = H(1) + H(2)
      W1 = (H(1) + HSUM)/HSUM
      W2 = -H(1)/HSUM
      D(1,1) = W1*DEL1 + W2*DEL2
      IF ( DPCHST(D(1,1),DEL1) .LE. ZERO)  THEN
         D(1,1) = ZERO
      ELSE IF ( DPCHST(DEL1,DEL2) .LT. ZERO)  THEN
C        NEED DO THIS CHECK ONLY IF MONOTONICITY SWITCHES.
         DMAX = THREE*DEL1
         IF (DABS(D(1,1)) .GT. DABS(DMAX))  D(1,1) = DMAX
      ENDIF
C
C  LOOP THROUGH INTERIOR POINTS.
C
      DO 50  I = 2, NLESS1
         IF (I .EQ. 2)  GO TO 40
C
         HSUM = H(I-1) + H(I)
         DEL1 = DEL2
         DEL2 = SLOPE(I)
   40    CONTINUE
C
C        SET D(I)=0 UNLESS DATA ARE STRICTLY MONOTONIC.
C
         D(1,I) = ZERO
         IF ( DPCHST(DEL1,DEL2) .LE. ZERO)  GO TO 50
C
C        USE BRODLIE MODIFICATION OF BUTLAND FORMULA.
C
         HSUMT3 = HSUM+HSUM+HSUM
         W1 = (HSUM + H(I-1))/HSUMT3
         W2 = (HSUM + H(I)  )/HSUMT3
         DMAX = DMAX1( DABS(DEL1), DABS(DEL2) )
         DMIN = DMIN1( DABS(DEL1), DABS(DEL2) )
         DRAT1 = DEL1/DMAX
         DRAT2 = DEL2/DMAX
         D(1,I) = DMIN/(W1*DRAT1 + W2*DRAT2)
C
   50 CONTINUE
C
C  SET D(N) VIA NON-CENTERED THREE-POINT FORMULA, ADJUSTED TO BE
C     SHAPE-PRESERVING.
C
      W1 = -H(N-1)/HSUM
      W2 = (H(N-1) + HSUM)/HSUM
      D(1,N) = W1*DEL1 + W2*DEL2
      IF ( DPCHST(D(1,N),DEL2) .LE. ZERO)  THEN
         D(1,N) = ZERO
      ELSE IF ( DPCHST(DEL1,DEL2) .LT. ZERO)  THEN
C        NEED DO THIS CHECK ONLY IF MONOTONICITY SWITCHES.
         DMAX = THREE*DEL2
         IF (DABS(D(1,N)) .GT. DABS(DMAX))  D(1,N) = DMAX
      ENDIF
C
C  NORMAL RETURN.
C
 5000 CONTINUE
      RETURN
C------------- LAST LINE OF DPCHCI FOLLOWS -----------------------------
      END
      SUBROUTINE DPCHSW (DFMAX, IEXTRM, D1, D2, H, SLOPE, IERR)
C
C-----------------------------------------------------------------------
C
C         DPCHSW:  DPCHCS SWITCH EXCURSION LIMITER.
C
C     CALLED BY  DPCHCS  TO ADJUST D1 AND D2 IF NECESSARY TO INSURE THAT
C     THE EXTREMUM ON THIS INTERVAL IS NOT FURTHER THAN DFMAX FROM THE
C     EXTREME DATA VALUE.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           CALL  DPCHSW (DFMAX, IEXTRM, D1, D2, H, SLOPE, IERR)
C
      INTEGER  IEXTRM, IERR
      DOUBLE PRECISION  DFMAX, D1, D2, H, SLOPE
C
C   PARAMETERS:
C
C     DFMAX -- (INPUT) MAXIMUM ALLOWED DIFFERENCE BETWEEN F(IEXTRM) AND
C           THE CUBIC DETERMINED BY DERIVATIVE VALUES D1,D2.  (ASSUMES
C           DFMAX.GT.0.)
C
C     IEXTRM -- (INPUT) INDEX OF THE EXTREME DATA VALUE.  (ASSUMES
C           IEXTRM = 1 OR 2 .  ANY VALUE .NE.1 IS TREATED AS 2.)
C
C     D1,D2 -- (INPUT) DERIVATIVE VALUES AT THE ENDS OF THE INTERVAL.
C           (ASSUMES D1*D2 .LE. 0.)
C          (OUTPUT) MAY BE MODIFIED IF NECESSARY TO MEET THE RESTRICTION
C           IMPOSED BY DFMAX.
C
C     H -- (INPUT) INTERVAL LENGTH.  (ASSUMES  H.GT.0.)
C
C     SLOPE -- (INPUT) DATA SLOPE ON THE INTERVAL.
C
C     IERR -- (OUTPUT) ERROR FLAG.  SHOULD BE ZERO.
C           IF IERR=-1, ASSUMPTION ON D1 AND D2 IS NOT SATISFIED.
C           IF IERR=-2, QUADRATIC EQUATION LOCATING EXTREMUM HAS
C                       NEGATIVE DESCRIMINANT (SHOULD NEVER OCCUR).
C
C    -------
C    WARNING:  THIS ROUTINE DOES NO VALIDITY-CHECKING OF ARGUMENTS.
C    -------
C
C
C  FORTRAN INTRINSICS USED:  DABS, DSIGN.
C  LIBRARY ROUTINES USED:  SQRT.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-04   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE DPCHSW TO DPCHSW WHEREVER IT OCCURS,
C        B. CHANGE ALL REFERENCES TO THE FORTRAN INTRINSICS TO THEIR
C           DOUBLE PRECISION EQUIVALENTS,
C        C. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION, AND
C        D. CHANGE CONSTANTS ZERO, ONE, TWO, ... TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      DOUBLE PRECISION  CP, DMAX, LAMBDA, NU, ONE, PHI,
     *  RADICA, RHO, SIGMA,SMALL,
     *      THAT, THIRD, THREE, TWO, ZERO
      DATA  ZERO /0.0D0/,  ONE /1.0D0/,  TWO /2.0D0/,  THREE /3.0D0/
C        THIRD SHOULD BE SLIGHTLY LESS THAN 1/3.
      DATA  THIRD /0.33333D0/
C        SMALL SHOULD BE A FEW ORDERS OF MAGNITUDE GREATER THAN MACHEPS.
      DATA  SMALL  /1.0D-10/
C
C  NOTATION AND GENERAL REMARKS.
C
C     RHO IS THE RATIO OF THE DATA SLOPE TO THE DERIVATIVE BEING TESTED.
C     LAMBDA IS THE RATIO OF D2 TO D1.
C     THAT = T-HAT(RHO) IS THE NORMALIZED LOCATION OF THE EXTREMUM.
C     PHI IS THE NORMALIZED VALUE OF P(X)-F1 AT X = XHAT = X-HAT(RHO),
C           WHERE  THAT = (XHAT - X1)/H .
C        THAT IS, P(XHAT)-F1 = D*H*PHI,  WHERE D=D1 OR D2.
C     SIMILARLY,  P(XHAT)-F2 = D*H*(PHI-RHO) .
C
C
C  DO MAIN CALCULATION.
C
      IF (D1 .EQ. ZERO)  THEN
C
C        SPECIAL CASE -- D1.EQ.ZERO .
C
C          IF D2 IS ALSO ZERO, THIS ROUTINE SHOULD NOT HAVE BEEN CALLED.
         IF (D2 .EQ. ZERO)  GO TO 5001
C
         RHO = SLOPE/D2
C          EXTREMUM IS OUTSIDE INTERVAL WHEN RHO .GE. 1/3 .
         IF (RHO .GE. THIRD)  GO TO 5000
         THAT = (TWO*(THREE*RHO-ONE)) / (THREE*(TWO*RHO-ONE))
         PHI = THAT**2 * ((THREE*RHO-ONE)/THREE)
C
C          CONVERT TO DISTANCE FROM F2 IF IEXTRM.NE.1 .
         IF (IEXTRM .NE. 1)  PHI = PHI - RHO
C
C          TEST FOR EXCEEDING LIMIT, AND ADJUST ACCORDINGLY.
         DMAX = DFMAX / (H*DABS(PHI))
         IF (DABS(D2) .GT. DMAX)  D2 = DSIGN (DMAX, D2)
      ELSE
C
         RHO = SLOPE/D1
         LAMBDA = -D2/D1
         IF (D2 .EQ. ZERO)  THEN
C
C           SPECIAL CASE -- D2.EQ.ZERO .
C
C             EXTREMUM IS OUTSIDE INTERVAL WHEN RHO .GE. 1/3 .
            IF (RHO .GE. THIRD)  GO TO 5000
            CP = TWO - THREE*RHO
            NU = ONE - TWO*RHO
            THAT = ONE / (THREE*NU)
         ELSE
            IF (LAMBDA .LE. ZERO)  GO TO 5001
C
C           NORMAL CASE -- D1 AND D2 BOTH NONZERO, OPPOSITE SIGNS.
C
            NU = ONE - LAMBDA - TWO*RHO
            SIGMA = ONE - RHO
            CP = NU + SIGMA
            IF (DABS(NU) .GT. SMALL)  THEN
               RADICA = (NU - (TWO*RHO+ONE))*NU + SIGMA**2
               IF (RADICA .LT. ZERO)  GO TO 5002
               THAT = (CP - SQRT(RADICA)) / (THREE*NU)
            ELSE
               THAT = ONE/(TWO*SIGMA)
            ENDIF
         ENDIF
         PHI = THAT*((NU*THAT - CP)*THAT + ONE)
C
C          CONVERT TO DISTANCE FROM F2 IF IEXTRM.NE.1 .
         IF (IEXTRM .NE. 1)  PHI = PHI - RHO
C
C          TEST FOR EXCEEDING LIMIT, AND ADJUST ACCORDINGLY.
         DMAX = DFMAX / (H*DABS(PHI))
         IF (DABS(D1) .GT. DMAX)  THEN
            D1 = DSIGN (DMAX, D1)
            D2 = -LAMBDA*D1
         ENDIF
      ENDIF
C
C  NORMAL RETURN.
C
 5000 CONTINUE
      IERR = 0
      RETURN
C
C  ERROR RETURNS.
C
 5001 CONTINUE
C     D1 AND D2 BOTH ZERO, OR BOTH NONZERO AND SAME SIGN.
      IERR = -1
      RETURN
C
 5002 CONTINUE
C     NEGATIVE VALUE OF RADICAL (SHOULD NEVER OCCUR).
      IERR = -2
      RETURN
C------------- LAST LINE OF DPCHSW FOLLOWS -----------------------------
      END
      DOUBLE PRECISION FUNCTION DPCHST (ARG1, ARG2)
      DOUBLE PRECISION  ARG1, ARG2
C
C-----------------------------------------------------------------------
C
C         PCHST:  PCHIP SIGN-TESTING ROUTINE.
C
C
C     RETURNS:
C        -1. IF ARG1 AND ARG2 ARE OF OPPOSITE SIGN.
C         0. IF EITHER ARGUMENT IS ZERO.
C        +1. IF ARG1 AND ARG2 ARE OF THE SAME SIGN.
C
C     THE OBJECT IS TO DO THIS WITHOUT MULTIPLYING ARG1*ARG2, TO AVOID
C     POSSIBLE OVER/UNDERFLOW PROBLEMS.
C
C  FORTRAN INTRINSICS USED:  SIGN.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-04   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHST TO DPCHST WHEREVER IT OCCURS,
C        B. CHANGE ALL REFERENCES TO THE FORTRAN INTRINSICS TO THEIR
C           DOUBLE PRESISION EQUIVALENTS,
C        C. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION, AND
C        D. CHANGE THE CONSTANTS  ZERO  AND  ONE  TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      DOUBLE PRECISION ONE, ZERO
      DATA  ZERO /0.D0/,  ONE /1.D0/
C
C  PERFORM THE TEST.
C
      DPCHST = DSIGN(ONE,ARG1) * DSIGN(ONE,ARG2)
      IF ((ARG1.EQ.ZERO) .OR. (ARG2.EQ.ZERO))  DPCHST = ZERO
C
      RETURN
C------------- LAST LINE OF PCHST FOLLOWS ------------------------------
      END
      SUBROUTINE DPCHCS (SWITCH, N, H, SLOPE, D, INCFD, IERR)
C
C-----------------------------------------------------------------------
C
C         PCHCS:  PCHIC MONOTONICITY SWITCH DERIVATIVE SETTER.
C
C     CALLED BY  PCHIC  TO ADJUST THE VALUES OF D IN THE VICINITY OF A
C     SWITCH IN DIRECTION OF MONOTONICITY, TO PRODUCE A MORE "VISUALLY
C     PLEASING" CURVE THAN THAT GIVEN BY  PCHIM .
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           CALL  PCHCS (SWITCH, N, H, SLOPE, D, INCFD, IERR)
C
      INTEGER  N, INCFD, IERR
      DOUBLE PRECISION SWITCH, H(N), SLOPE(N), D(INCFD,N)
C
C   PARAMETERS:
C
C     SWITCH -- (INPUT) INDICATES THE AMOUNT OF CONTROL DESIRED OVER
C           LOCAL EXCURSIONS FROM DATA.
C
C     N -- (INPUT) NUMBER OF DATA POINTS.  (ASSUMES N.GT.2 .)
C
C     H -- (INPUT) REAL ARRAY OF INTERVAL LENGTHS.
C     SLOPE -- (INPUT) REAL ARRAY OF DATA SLOPES.
C           IF THE DATA ARE (X(I),Y(I)), I=1(1)N, THEN THESE INPUTS ARE:
C                  H(I) =  X(I+1)-X(I),
C              SLOPE(I) = (Y(I+1)-Y(I))/H(I),  I=1(1)N-1.
C
C     D -- (INPUT) REAL ARRAY OF DERIVATIVE VALUES AT THE DATA POINTS,
C           AS DETERMINED BY PCHCI.
C          (OUTPUT) DERIVATIVES IN THE VICINITY OF SWITCHES IN DIRECTION
C           OF MONOTONICITY MAY BE ADJUSTED TO PRODUCE A MORE "VISUALLY
C           PLEASING" CURVE.
C           THE VALUE CORRESPONDING TO X(I) IS STORED IN
C                D(1+(I-1)*INCFD),  I=1(1)N.
C           NO OTHER ENTRIES IN D ARE CHANGED.
C
C     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN D.
C           THIS ARGUMENT IS PROVIDED PRIMARILY FOR 2-D APPLICATIONS.
C
C     IERR -- (OUTPUT) ERROR FLAG.  SHOULD BE ZERO.
C           IF NEGATIVE, TROUBLE IN PCHSW.  (SHOULD NEVER HAPPEN.)
C
C    -------
C    WARNING:  THIS ROUTINE DOES NO VALIDITY-CHECKING OF ARGUMENTS.
C    -------
C
C
C  FORTRAN INTRINSICS USED:  ABS, AMAX1, AMIN1.
C  OTHER ROUTINES USED:  PCHST, PCHSW.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-06-17   REDESIGNED TO (1) FIX  PROBLEM WITH LACK OF CONTINUITY
C                APPROACHING A FLAT-TOPPED PEAK (2) BE CLEANER AND
C                EASIER TO VERIFY.
C                ELIMINATED SUBROUTINES PCHSA AND PCHSX IN THE PROCESS.
C     82-06-22   1. LIMITED FACT TO NOT EXCEED ONE, SO COMPUTED D IS A
C                   CONVEX COMBINATION OF PCHCI VALUE AND PCHSD VALUE.
C                2. CHANGED FUDGE FROM 1 TO 4 (BASED ON EXPERIMENTS).
C     82-06-23   MOVED PCHSD TO AN INLINE FUNCTION (ELIMINATING MSWTYP).
C     82-08-04   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     1. THE FUNCTION  PCHST(ARG1,ARG2)  IS ASSUMED TO RETURN ZERO IF
C        EITHER ARGUMENT IS ZERO, +1 IF THEY ARE OF THE SAME SIGN, AND
C        -1 IF THEY ARE OF OPPOSITE SIGN.
C     2. TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHCS TO DPCHCS WHEREVER IT OCCURS,
C        B. CHANGE DPCHSD TO DDPCHSD WHEREVER IT OCCURS,
C        C. CHANGE DPCHST TO DPCHST WHEREVER IT OCCURS,
C        D. CHANGE DPCHSW TO DPCHSW WHEREVER IT OCCURS,
C        E. CHANGE ALL REFERENCES TO THE FORTRAN INTRINSICS TO THEIR
C           DOUBLE PRECISION EQUIVALENTS,
C        F. CHANGE THE REAL*8 DECLARATIONS TO DOUBLE PRECISION, AND
C        G. CHANGE THE CONSTANTS ZERO AND ONE TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I, INDX, K, NLESS1
      DOUBLE PRECISION  DEL(3),DEXT,DFLOC,DFMX,FACT,FUDGE,ONE,SLMAX,
     *      WTAVE(2), ZERO
      DOUBLE PRECISION  DPCHST
C
C  DEFINE INLINE FUNCTION FOR WEIGHTED AVERAGE OF SLOPES.
C
      DOUBLE PRECISION  DPCHSD, S1, S2, H1, H2
      DPCHSD(S1,S2,H1,H2) = (H2/(H1+H2))*S1 + (H1/(H1+H2))*S2
C
C  INITIALIZE.
C
      DATA  ZERO /0.D0/,  ONE /1.D0/
      DATA  FUDGE /4.D0/
      IERR = 0
      NLESS1 = N - 1
C
C  LOOP OVER SEGMENTS.
C
      DO 900  I = 2, NLESS1
         IF ( DPCHST(SLOPE(I-1),SLOPE(I)) )  100, 300, 900
C             --------------------------
C
  100    CONTINUE
C
C....... SLOPE SWITCHES MONOTONICITY AT I-TH POINT .....................
C
C           DO NOT CHANGE D IF "UP-DOWN-UP".
            IF (I .GT. 2)  THEN
               IF ( DPCHST(SLOPE(I-2),SLOPE(I)) .GT. ZERO)  GO TO 900
C                   --------------------------
            ENDIF
            IF (I .LT. NLESS1)  THEN
               IF ( DPCHST(SLOPE(I+1),SLOPE(I-1)) .GT. ZERO)  GO TO 900
C                   ----------------------------
            ENDIF
C
C   ....... COMPUTE PROVISIONAL VALUE FOR D(1,I).
C
            DEXT = DPCHSD (SLOPE(I-1), SLOPE(I), H(I-1), H(I))
C
C   ....... DETERMINE WHICH INTERVAL CONTAINS THE EXTREMUM.
C
            IF ( DPCHST(DEXT, SLOPE(I-1)) )  200, 900, 250
C                -----------------------
C
  200       CONTINUE
C              DEXT AND SLOPE(I-1) HAVE OPPOSITE SIGNS --
C                        EXTREMUM IS IN (X(I-1),X(I)).
               K = I-1
C              SET UP TO COMPUTE NEW VALUES FOR D(1,I-1) AND D(1,I).
               WTAVE(2) = DEXT
               IF (K .GT. 1)
     *            WTAVE(1) = DPCHSD (SLOPE(K-1), SLOPE(K), H(K-1), H(K))
               GO TO 400
C
  250       CONTINUE
C              DEXT AND SLOPE(I) HAVE OPPOSITE SIGNS --
C                        EXTREMUM IS IN (X(I),X(I+1)).
               K = I
C              SET UP TO COMPUTE NEW VALUES FOR D(1,I) AND D(1,I+1).
               WTAVE(1) = DEXT
               IF (K .LT. NLESS1)
     *            WTAVE(2) = DPCHSD (SLOPE(K), SLOPE(K+1), H(K), H(K+1))
               GO TO 400
C
  300    CONTINUE
C
C....... AT LEAST ONE OF SLOPE(I-1) AND SLOPE(I) IS ZERO --
C                     CHECK FOR FLAT-TOPPED PEAK .......................
C
            IF (I .EQ. NLESS1)  GO TO 900
            IF ( DPCHST(SLOPE(I-1), SLOPE(I+1)) .GE. ZERO)  GO TO 900
C                -----------------------------
C
C           WE HAVE FLAT-TOPPED PEAK ON (X(I),X(I+1)).
            K = I
C           SET UP TO COMPUTE NEW VALUES FOR D(1,I) AND D(1,I+1).
            WTAVE(1) = DPCHSD (SLOPE(K-1), SLOPE(K), H(K-1), H(K))
            WTAVE(2) = DPCHSD (SLOPE(K), SLOPE(K+1), H(K), H(K+1))
C
  400    CONTINUE
C
C....... AT THIS POINT WE HAVE DETERMINED THAT THERE WILL BE AN EXTREMUM
C        ON (X(K),X(K+1)), WHERE K=I OR I-1, AND HAVE SET ARRAY WTAVE:
C           WTAVE(1) IS A WEIGHTED AVERAGE OF SLOPE(K-1) AND SLOPE(K),
C                    IF K.GT.1;
C           WTAVE(2) IS A WEIGHTED AVERAGE OF SLOPE(K) AND SLOPE(K+1),
C                    IF K.LT.N-1 .
         SLMAX = DABS(SLOPE(K))
         IF (K .GT. 1)    SLMAX = DMAX1( SLMAX, DABS(SLOPE(K-1)) )
         IF (K.LT.NLESS1) SLMAX = DMAX1( SLMAX, DABS(SLOPE(K+1)) )
C
         IF (K .GT. 1)  DEL(1) = SLOPE(K-1) / SLMAX
         DEL(2) = SLOPE(K) / SLMAX
         IF (K.LT.NLESS1)  DEL(3) = SLOPE(K+1) / SLMAX
C
         IF ((K.GT.1) .AND. (K.LT.NLESS1))  THEN
C           NORMAL CASE -- EXTREMUM IS NOT IN A BOUNDARY INTERVAL.
            FACT = FUDGE* DABS(DEL(3)*(DEL(1)-DEL(2))*(WTAVE(2)/SLMAX))
            D(1,K) = D(1,K) + DMIN1(FACT,ONE)*(WTAVE(1) - D(1,K))
            FACT = FUDGE* DABS(DEL(1)*(DEL(3)-DEL(2))*(WTAVE(1)/SLMAX))
            D(1,K+1) = D(1,K+1) + DMIN1(FACT,ONE)*(WTAVE(2) - D(1,K+1))
         ELSE
C           SPECIAL CASE K=1 (WHICH CAN OCCUR ONLY IF I=2) OR
C                        K=NLESS1 (WHICH CAN OCCUR ONLY IF I=NLESS1).
            FACT = FUDGE* DABS(DEL(2))
            D(1,I) = DMIN1(FACT,ONE) * WTAVE(I-K+1)
C              NOTE THAT I-K+1 = 1 IF K=I  (=NLESS1),
C                        I-K+1 = 2 IF K=I-1(=1).
         ENDIF
C
C
C....... ADJUST IF NECESSARY TO LIMIT EXCURSIONS FROM DATA.
C
         IF (SWITCH .LE. ZERO)  GO TO 900
         DFLOC = H(K)*DABS(SLOPE(K))
         IF (K .GT. 1)    DFLOC = DMAX1(DFLOC,H(K-1)*DABS(SLOPE(K-1)))
         IF (K.LT.NLESS1) DFLOC = DMAX1(DFLOC,H(K+1)*DABS(SLOPE(K+1)))
         DFMX = SWITCH*DFLOC
         INDX = I-K+1
C        INDX = 1 IF K=I, 2 IF K=I-1.
C        ---------------------------------------------------------------
         CALL DPCHSW (DFMX,INDX, D(1,K), D(1,K+1), H(K), SLOPE(K),IERR)
C        ---------------------------------------------------------------
         IF (IERR .NE. 0)  RETURN
C
C....... END OF SEGMENT LOOP.
C
  900 CONTINUE
C
      RETURN
C------------- LAST LINE OF DPCHCS FOLLOWS -----------------------------
      END
      DOUBLE PRECISION FUNCTION DPCHDF (K, X, S, IERR)
      INTEGER  K, IERR
      DOUBLE PRECISION  X(K), S(K)
C
C-----------------------------------------------------------------------
C
C          PCHDF:   PCHIP FINITE DIFFERENCE FORMULA
C
C     USES A DIVIDED DIFFERENCE FORMULATION TO COMPUTE A K-POINT APPROX-
C     IMATION TO THE DERIVATIVE AT X(K) BASED ON THE DATA IN X AND S.
C
C     CALLED BY  PCHCE  AND  PCHSP  TO COMPUTE 3- AND 4-POINT BOUNDARY
C     DERIVATIVE APPROXIMATIONS.
C
C-----------------------------------------------------------------------
C
C     ON INPUT:
C        K      IS THE ORDER OF THE DESIRED DERIVATIVE APPROXIMATION.
C               K MUST BE AT LEAST 3 (ERROR RETURN IF NOT).
C        X      CONTAINS THE K VALUES OF THE INDEPENDENT VARIABLE.
C               X NEED NOT BE ORDERED, BUT THE VALUES **MUST** BE
C               DISTINCT.  (NOT CHECKED HERE.)
C        S      CONTAINS THE ASSOCIATED SLOPE VALUES:
C                  S(I) = (F(I+1)-F(I))/(X(I+1)-X(I)), I=1(1)K-1.
C               (NOTE THAT S NEED ONLY BE OF LENGTH K-1.)
C
C     ON RETURN:
C        S      WILL BE DESTROYED.
C        IERR   WILL BE SET TO -1 IF K.LT.2 .
C        PCHDF  WILL BE SET TO THE DESIRED DERIVATIVE APPROXIMATION IF
C               IERR=0 OR TO ZERO IF IERR=-1.
C
C-----------------------------------------------------------------------
C
C  REFERENCE:  CARL DE BOOR, A PRACTICAL GUIDE TO SPLINES, SPRINGER-
C              VERLAG (NEW YORK, 1978), PP. 10-16.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-04   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHDF TO DPCHDF WHEREVER IT OCCURS,
C        B. CHANGE THE REAL*8 DECLARATIONS TO DOUBLE PRECISION, AND
C        C. CHANGE THE CONSTANT ZERO TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I, J
      DOUBLE PRECISION  VALUE, ZERO
      DATA  ZERO /0.D0/
C
C  CHECK FOR LEGAL VALUE OF K.
C
      IF (K .LT. 3)  GO TO 5001
C
C  COMPUTE COEFFICIENTS OF INTERPOLATING POLYNOMIAL.
C
      KM1=K-1
CBUG
CBUG  KMJ=K-J
      DO 10  J = 2, KM1
      KMJ=K-J
         DO 9  I = 1, KMJ
            S(I) = (S(I+1)-S(I))/(X(I+J)-X(I))
    9    CONTINUE
   10 CONTINUE
C
C  EVALUATE DERIVATIVE AT X(K).
C
      VALUE = S(1)
      DO 20  I = 2, KM1
         VALUE = S(I) + VALUE*(X(K)-X(I))
   20 CONTINUE
C
C  NORMAL RETURN.
C
      IERR = 0
      DPCHDF = VALUE
      RETURN
C
C  ERROR RETURN.
C
 5001 CONTINUE
C     K.LT.3 RETURN.
      IERR = -1
      DPCHDF = ZERO
      RETURN
C------------- LAST LINE OF PCHDF FOLLOWS ------------------------------
      END
      SUBROUTINE DPCHFE (N, X, F, D, INCFD, SKIP, NE, XE, FE, IERR)
C
C-----------------------------------------------------------------------
C
C          DPCHFE:  PIECEWISE CUBIC HERMITE FUNCTION EVALUATOR
C
C     EVALUATES THE CUBIC HERMITE FUNCTION DEFINED BY  N, X, F, D  AT
C     THE POINTS  XE(J), J=1(1)NE.
C
C     TO PROVIDE COMPATIBILITY WITH DPCHIM AND DPCHIC, INCLUDES AN
C     INCREMENT BETWEEN SUCCESSIVE VALUES OF THE F- AND D-ARRAYS.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           CALL  DPCHFE (N, X, F, D, INCFD, SKIP, NE, XE, FE, IERR)
C
      INTEGER  N, INCFD, NE, IERR
      DOUBLE PRECISION  X(N), F(INCFD,N), D(INCFD,N), XE(NE), FE(NE)
      LOGICAL  SKIP
C
C   PARAMETERS:
C
C     N -- (INPUT) NUMBER OF DATA POINTS.  (ERROR RETURN IF N.LT.2 .)
C
C     X -- (INPUT) REAL ARRAY OF INDEPENDENT VARIABLE VALUES.  THE
C           ELEMENTS OF X MUST BE STRICTLY INCREASING:
C                X(I-1) .LT. X(I),  I = 2(1)N.
C           (ERROR RETURN IF NOT.)
C
C     F -- (INPUT) REAL ARRAY OF FUNCTION VALUES.  F(1+(I-1)*INCFD) IS
C           THE VALUE CORRESPONDING TO X(I).
C
C     D -- (INPUT) REAL ARRAY OF DERIVATIVE VALUES.  D(1+(I-1)*INCFD) IS
C           THE VALUE CORRESPONDING TO X(I).
C
C     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN F AND D.
C           (ERROR RETURN IF  INCFD.LT.1 .)
C
C     SKIP -- (INPUT/OUTPUT) LOGICAL VARIABLE WHICH SHOULD BE SET TO
C           .TRUE. IF THE USER WISHES TO SKIP CHECKS FOR VALIDITY OF
C           PRECEDING PARAMETERS, OR TO .FALSE. OTHERWISE.
C           THIS WILL SAVE TIME IN CASE THESE CHECKS HAVE ALREADY
C           BEEN PERFORMED (SAY, IN DPCHIM OR DPCHIC).
C           SKIP WILL BE SET TO .TRUE. ON NORMAL RETURN.
C
C     NE -- (INPUT) NUMBER OF EVALUATION POINTS.  (ERROR RETURN IF
C           NE.LT.1 .)
C
C     XE -- (INPUT) REAL ARRAY OF POINTS AT WHICH THE FUNCTION IS TO BE
C           EVALUATED.
C          NOTES:
C           1. THE EVALUATION WILL BE MOST EFFICIENT IF THE ELEMENTS
C              OF XE ARE INCREASING RELATIVE TO X;
C              THAT IS,   XE(J) .GE. X(I)
C              IMPLIES    XE(K) .GE. X(I),  ALL K.GE.J .
C           2. IF ANY OF THE XE ARE OUTSIDE THE INTERVAL @X(1),X(N)@,
C              VALUES ARE EXTRAPOLATED FROM THE NEAREST EXTREME CUBIC,
C              AND A WARNING ERROR IS RETURNED.
C
C     FE -- (OUTPUT) REAL ARRAY OF VALUES OF THE CUBIC HERMITE FUNCTION
C           DEFINED BY  N, X, F, D  AT THE POINTS  XE.
C
C     IERR -- (OUTPUT) ERROR FLAG.
C           NORMAL RETURN:
C              IERR = 0  (NO ERRORS).
C           WARNING ERROR:
C              IERR.GT.0  MEANS THAT EXTRAPOLATION WAS PERFORMED AT
C                 IERR POINTS.
C           "RECOVERABLE" ERRORS:
C              IERR = -1  IF N.LT.2 .
C              IERR = -2  IF INCFD.LT.1 .
C              IERR = -3  IF THE X-ARRAY IS NOT STRICTLY INCREASING.
C              IERR = -4  IF NE.LT.1 .
C             (THE FE-ARRAY HAS NOT BEEN CHANGED IN ANY OF THESE CASES.)
C               NOTE:  THE ABOVE ERRORS ARE CHECKED IN THE ORDER LISTED,
C                   AND FOLLOWING ARGUMENTS HAVE **NOT** BEEN VALIDATED.
C              IERR = -5  IF AN ERROR HAS OCCURRED IN THE LOWER-LEVEL
C                         ROUTINE DCHFEV.  NB: THIS SHOULD NEVER HAPPEN.
C                         NOTIFY THE AUTHOR **IMMEDIATELY** IF IT DOES.
C
C  OTHER ROUTINES USED:  DCHFEV.
C
C-----------------------------------------------------------------------
C
C     PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                     MATHEMATICS AND STATISTICS DIVISION,
C                     LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C     CHANGE RECORD:
C        82-08-03   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     1. TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHFE TO DPCHFE, AND CHFEV TO DCHFEV, WHEREVER THEY
C           OCCUR,
C        B. CHANGE THE REAL DECLARATION TO DOUBLE PRECISION,
C
C     2. MOST OF THE CODING BETWEEN THE CALL TO DCHFEV AND THE END OF
C        THE IR-LOOP COULD BE ELIMINATED IF IT WERE PERMISSIBLE TO
C        ASSUME THAT XE IS ORDERED RELATIVE TO X.
C
C     3. DCHFEV DOES NOT ASSUME THAT X1 IS LESS THAN X2. THUS, IT WOULD
C        BE POSSIBLE TO WRITE A VERSION OF PCHFE THAT ASSUMES A STRICT-
C        LY DECREASING X-ARRAY BY SIMPLY RUNNING THE IR-LOOP BACKWARDS
C        (AND REVERSING THE ORDER OF APPROPRIATE TESTS).
C
C     4. THE PRESENT CODE HAS A MINOR BUG, WHICH I HAVE DECIDED IS NOT
C        WORTH THE EFFORT THAT WOULD BE REQUIRED TO FIX IT.
C        IF XE CONTAINS POINTS IN @X(N-1),X(N)@, FOLLOWED BY POINTS .LT.
C        X(N-1), FOLLOWED BY POINTS .GT.X(N), THE EXTRAPOLATION POINTS
C        WILL BE COUNTED (AT LEAST) TWICE IN THE TOTAL RETURNED IN IERR.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I, IERC, IR, J, JFIRST, NEXT(2), NJ
C
C  VALIDITY-CHECK ARGUMENTS.
C
      IF (SKIP)  GO TO 5
C
      IF ( N.LT.2 )  GO TO 5001
      IF ( INCFD.LT.1 )  GO TO 5002
      DO 1  I = 2, N
         IF ( X(I).LE.X(I-1) )  GO TO 5003
    1 CONTINUE
C
C  FUNCTION DEFINITION IS OK, GO ON.
C
    5 CONTINUE
      IF ( NE.LT.1 )  GO TO 5004
      IERR = 0
      SKIP = .TRUE.
C
C  LOOP OVER INTERVALS.        (   INTERVAL INDEX IS  IL = IR-1  . )
C                              ( INTERVAL IS X(IL).LE.X.LT.X(IR) . )
      JFIRST = 1
      IR = 2
   10 CONTINUE
C
C     SKIP OUT OF LOOP IF HAVE PROCESSED ALL EVALUATION POINTS.
C
         IF (JFIRST .GT. NE)  GO TO 5000
C
C     LOCATE ALL POINTS IN INTERVAL.
C
         DO 20  J = JFIRST, NE
            IF (XE(J) .GE. X(IR))  GO TO 30
   20    CONTINUE
         J = NE + 1
         GO TO 40
C
C     HAVE LOCATED FIRST POINT BEYOND INTERVAL.
C
   30    CONTINUE
         IF (IR .EQ. N)  J = NE + 1
C
   40    CONTINUE
         NJ = J - JFIRST
C
C     SKIP EVALUATION IF NO POINTS IN INTERVAL.
C
         IF (NJ .EQ. 0)  GO TO 50
C
C     EVALUATE CUBIC AT XE(I),  I = JFIRST (1) J-1 .
C
C       ----------------------------------------------------------------
        CALL DCHFEV (X(IR-1),X(IR),F(1,IR-1),F(1,IR),D(1,IR-1),D(1,IR),
     *              NJ, XE(JFIRST), FE(JFIRST), NEXT, IERC)
C       ----------------------------------------------------------------
         IF (IERC .LT. 0)  GO TO 5005
C
         IF (NEXT(2) .GT. 0)  THEN
C           IN THE CURRENT SET OF XE-POINTS, THERE ARE NEXT(2) TO THE
C           RIGHT OF X(IR).
C
            IF (IR .EQ. N)  THEN
C              THESE ARE ACTUALLY EXTRAPOLATION POINTS.
               IERR = IERR + NEXT(2)
            ELSE
C              WE SHOULD NEVER HAVE GOTTEN HERE.
               GO TO 5005
            ENDIF
         ENDIF
C
         IF (NEXT(1) .GT. 0)  THEN
C           IN THE CURRENT SET OF XE-POINTS, THERE ARE NEXT(1) TO THE
C           LEFT OF X(IR-1).
C
            IF (IR .EQ. 2)  THEN
C              THESE ARE ACTUALLY EXTRAPOLATION POINTS.
               IERR = IERR + NEXT(1)
            ELSE
C              XE IS NOT ORDERED RELATIVE TO X, SO MUST ADJUST
C              EVALUATION INTERVAL.
C
C              FIRST, LOCATE FIRST POINT TO LEFT OF X(IR-1).
               JM1=J-1
               DO 44  I = JFIRST, JM1
                  IF (XE(I) .LT. X(IR-1))  GO TO 45
   44          CONTINUE
C              NOTE:  CANNOT DROP THROUGH HERE UNLESS THERE IS AN ERROR
C                     IN DCHFEV.
               GO TO 5005
C
   45          CONTINUE
C              RESET J.  (THIS WILL BE THE NEW JFIRST.)
               J = I
C
C              NOW FIND OUT HOW FAR TO BACK UP IN THE X-ARRAY.
               IRM1=IR-1
               DO 46  I = 1, IRM1
                  IF (XE(J) .LT. X(I)) GO TO 47
   46          CONTINUE
C              NB:  CAN NEVER DROP THROUGH HERE, SINCE XE(J).LT.X(IR-1).
C
   47          CONTINUE
C              AT THIS POINT, EITHER  XE(J) .LT. X(1)
C                 OR      X(I-1) .LE. XE(J) .LT. X(I) .
C              RESET IR, RECOGNIZING THAT IT WILL BE INCREMENTED BEFORE
C              CYCLING.
               IR = MAX0(1, I-1)
            ENDIF
         ENDIF
C
         JFIRST = J
C
C     END OF IR-LOOP.
C
   50 CONTINUE
      IR = IR + 1
      IF (IR .LE. N)  GO TO 10
C
C  NORMAL RETURN.
C
 5000 CONTINUE
      RETURN
C
C  ERROR RETURNS.
C
 5001 CONTINUE
C     N.LT.2 RETURN.
      IERR = -1
      RETURN
C
 5002 CONTINUE
C     INCFD.LT.1 RETURN.
      IERR = -2
      RETURN
C
 5003 CONTINUE
C     X-ARRAY NOT STRICTLY INCREASING.
      IERR = -3
      RETURN
C
 5004 CONTINUE
C     NE.LT.1 RETURN.
      IERR = -4
      RETURN
C
 5005 CONTINUE
C     ERROR RETURN FROM DCHFEV.
C   *** THIS CASE SHOULD NEVER OCCUR ***
      IERR = -5
      RETURN
C------------- LAST LINE OF DPCHFE FOLLOWS -----------------------------
      END
      SUBROUTINE DCHFEV (X1,X2,F1,F2,D1,D2,NE, XE, FE, NEXT, IERR)
C
C-----------------------------------------------------------------------
C
C          DCHFEV:  CUBIC HERMITE FUNCTION EVALUATOR
C
C     EVALUATES THE CUBIC POLYNOMIAL DETERMINED BY FUNCTION VALUES
C     F1,F2 AND DERIVATIVES D1,D2 ON INTERVAL (X1,X2) AT THE POINTS
C     XE(J), J=1(1)NE.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           CALL  DCHFEV (X1,X2,F1,F2,D1,D2, NE, XE, FE, NEXT, IERR)
C
      INTEGER  NE, NEXT(2), IERR
      DOUBLE PRECISION  X1, X2, F1, F2, D1, D2, XE(NE), FE(NE)
C
C   PARAMETERS:
C
C     X1,X2 -- (INPUT) ENDPOINTS OF INTERVAL OF DEFINITION OF CUBIC.
C           (ERROR RETURN IF  X1.EQ.X2 .)
C
C     F1,F2 -- (INPUT) VALUES OF FUNCTION AT X1 AND X2, RESPECTIVELY.
C
C     D1,D2 -- (INPUT) VALUES OF DERIVATIVE AT X1 AND X2, RESPECTIVELY.
C
C     NE -- (INPUT) NUMBER OF EVALUATION POINTS.  (ERROR RETURN IF
C           NE.LT.1 .)
C
C     XE -- (INPUT) REAL ARRAY OF POINTS AT WHICH THE FUNCTIONS ARE TO
C           BE EVALUATED.  IF ANY OF THE XE ARE OUTSIDE THE INTERVAL
C           @X1,X2@, A WARNING ERROR IS RETURNED.
C
C     FE -- (OUTPUT) REAL ARRAY OF VALUES OF THE CUBIC FUNCTION DEFINED
C           BY  X1,X2, F1,F2, D1,D2  AT THE POINTS  XE.
C
C     NEXT -- (OUTPUT) INTEGER ARRAY INDICATING NUMBER OF EXTRAPOLATION
C           POINTS:
C            NEXT(1) = NUMBER OF EVALUATION POINTS TO LEFT OF INTERVAL.
C            NEXT(2) = NUMBER OF EVALUATION POINTS TO RIGHT OF INTERVAL.
C
C     IERR -- (OUTPUT) ERROR FLAG.
C           NORMAL RETURN:
C              IERR = 0  (NO ERRORS).
C           "RECOVERABLE" ERRORS:
C              IERR = -1  IF NE.LT.1 .
C              IERR = -2  IF X1.EQ.X2 .
C                (OUTPUT ARRAYS HAVE NOT BEEN CHANGED IN EITHER CASE.)
C
C  FORTRAN INTRINSICS USED:  DMAX1, DMIN1.
C
C-----------------------------------------------------------------------
C
C     PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                     MATHEMATICS AND STATISTICS DIVISION,
C                     LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C     CHANGE RECORD:
C        82-08-03   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE CHFEV TO DCHFEV WHEREVER IT OCCURS,
C        B. CHANGE THE REAL DECLARATION TO DOUBLE PRECISION,
C        C. CHANGE THE CONSTANT ZERO TO DOUBLE PRECISION, AND
C        D. CHANGE THE NAMES OF THE FORTRAN INTRINSICS TO THEIR DOUBLE
C           PRECISION EQUIVALENTS.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I
      DOUBLE PRECISION  C2, C3, DEL1, DEL2, DELTA, H, X, XMI, XMA, ZERO
      DATA  ZERO /0.0D0/
C
C  VALIDITY-CHECK ARGUMENTS.
C
      IF (NE .LT. 1)  GO TO 5001
      H = X2 - X1
      IF (H .EQ. ZERO)  GO TO 5002
C
C  INITIALIZE.
C
      IERR = 0
      NEXT(1) = 0
      NEXT(2) = 0
      XMI = DMIN1(ZERO, H)
      XMA = DMAX1(ZERO, H)
C
C  COMPUTE CUBIC COEFFICIENTS (EXPANDED ABOUT X1).
C
      DELTA = (F2 - F1)/H
      DEL1 = (D1 - DELTA)/H
      DEL2 = (D2 - DELTA)/H
C                                           (DELTA IS NO LONGER NEEDED.)
      C2 = -(DEL1+DEL1 + DEL2)
      C3 = (DEL1 + DEL2)/H
C                               (H, DEL1 AND DEL2 ARE NO LONGER NEEDED.)
C
C  EVALUATION LOOP.
C
      DO 500  I = 1, NE
         X = XE(I) - X1
         FE(I) = F1 + X*(D1 + X*(C2 + X*C3))
C          COUNT EXTRAPOLATION POINTS.
         IF ( X.LT.XMI )  THEN
            NEXT(1) = NEXT(1) + 1
         ELSE IF ( X.GT.XMA )  THEN
            NEXT(2) = NEXT(2) + 1
         ENDIF
  500 CONTINUE
C
C  NORMAL RETURN.
C
      RETURN
C
C  ERROR RETURNS.
C
 5001 CONTINUE
C     NE.LT.1 RETURN.
      IERR = -1
      RETURN
C
 5002 CONTINUE
C     X1.EQ.X2 RETURN.
      IERR = -2
      RETURN
C------------- LAST LINE OF DCHFEV FOLLOWS -----------------------------
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      END
      DOUBLE PRECISION FUNCTION DPCHIA (N, X, F, D,
     1       INCFD, SKIP, A, B, IERR)
C
C-----------------------------------------------------------------------
C
C          PCHIA:  PIECEWISE CUBIC HERMITE INTEGRATOR, ARBITRARY LIMITS
C
C     EVALUATES THE DEFINITE INTEGRAL OF THE CUBIC HERMITE FUNCTION
C     DEFINED BY  N, X, F, D  OVER THE INTERVAL @A, B@.
C
C     TO PROVIDE COMPATIBILITY WITH PCHIM AND PCHIC, INCLUDES AN
C     INCREMENT BETWEEN SUCCESSIVE VALUES OF THE F- AND D-ARRAYS.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           VALUE = PCHIA (N, X, F, D, INCFD, SKIP, A, B, IERR)
C
      INTEGER  N, INCFD, IERR
      DOUBLE PRECISION  X(N), F(INCFD,N), D(INCFD,N), A, B
      LOGICAL  SKIP
C
C   PARAMETERS:
C
C     VALUE -- (OUTPUT) VALUE OF THE REQUESTED INTEGRAL.
C
C     N -- (INPUT) NUMBER OF DATA POINTS.  (ERROR RETURN IF N.LT.2 .)
C
C     X -- (INPUT) REAL ARRAY OF INDEPENDENT VARIABLE VALUES.  THE
C           ELEMENTS OF X MUST BE STRICTLY INCREASING:
C                X(I-1) .LT. X(I),  I = 2(1)N.
C           (ERROR RETURN IF NOT.)
C
C     F -- (INPUT) REAL ARRAY OF FUNCTION VALUES.  F(1+(I-1)*INCFD) IS
C           THE VALUE CORRESPONDING TO X(I).
C
C     D -- (INPUT) REAL ARRAY OF DERIVATIVE VALUES.  D(1+(I-1)*INCFD) IS
C           THE VALUE CORRESPONDING TO X(I).
C
C     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN F AND D.
C           (ERROR RETURN IF  INCFD.LT.1 .)
C
C     SKIP -- (INPUT/OUTPUT) LOGICAL VARIABLE WHICH SHOULD BE SET TO
C           .TRUE. IF THE USER WISHES TO SKIP CHECKS FOR VALIDITY OF
C           PRECEDING PARAMETERS, OR TO .FALSE. OTHERWISE.
C           THIS WILL SAVE TIME IN CASE THESE CHECKS HAVE ALREADY
C           BEEN PERFORMED (SAY, IN PCHIM OR PCHIC).
C           SKIP WILL BE SET TO .TRUE. ON RETURN WITH IERR.GE.0 .
C
C     A,B -- (INPUT) THE LIMITS OF INTEGRATION.
C           NOTE:  THERE IS NO REQUIREMENT THAT @A,B@ BE CONTAINED IN
C                  @X(1),X(N)@.  HOWEVER, THE RESULTING INTEGRAL VALUE
C                  WILL BE HIGHLY SUSPECT, IF NOT.
C
C     IERR -- (OUTPUT) ERROR FLAG.
C           NORMAL RETURN:
C              IERR = 0  (NO ERRORS).
C           WARNING ERRORS:
C              IERR = 1  IF  A  IS OUTSIDE THE INTERVAL @X(1),X(N)@.
C              IERR = 2  IF  B  IS OUTSIDE THE INTERVAL @X(1),X(N)@.
C              IERR = 3  IF BOTH OF THE ABOVE ARE TRUE.  (NOTE THAT THIS
C                        MEANS THAT EITHER @A,B@ CONTAINS DATA INTERVAL
C                        OR THE INTERVALS TO NOT INTERSECT AT ALL.)
C           "RECOVERABLE" ERRORS:
C              IERR = -1  IF N.LT.2 .
C              IERR = -2  IF INCFD.LT.1 .
C              IERR = -3  IF THE X-ARRAY IS NOT STRICTLY INCREASING.
C                (VALUE HAS NOT BEEN COMPUTED IN ANY OF THESE CASES.)
C               NOTE:  THE ABOVE ERRORS ARE CHECKED IN THE ORDER LISTED,
C                   AND FOLLOWING ARGUMENTS HAVE **NOT** BEEN VALIDATED.
C
C
C  FORTRAN INTRINSICS USED:  AMAX1, AMIN1, MAX0, MIN0.
C  OTHER ROUTINES USED:  DCHFIV, PCHID.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-03   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHIA TO DPCHIA WHEREVER IT OCCURS,
C        B. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION,  AND
C        C. CHANGE THE CONSTANT  ZERO  TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I, IA, IB, IERD, IERV, IL, IR
      DOUBLE PRECISION  VALUE, XA, XB, ZERO
      DOUBLE PRECISION  DCHFIV, DPCHID
C
C  INITIALIZE.
C
      DATA  ZERO /0.D0/
C
C  VALIDITY-CHECK ARGUMENTS.
C
      IF (SKIP)  GO TO 5
C
      IF ( N.LT.2 )  GO TO 5001
      IF ( INCFD.LT.1 )  GO TO 5002
      DO 1  I = 2, N
         IF ( X(I).LE.X(I-1) )  GO TO 5003
    1 CONTINUE
C
C  FUNCTION DEFINITION IS OK, GO ON.
C
    5 CONTINUE
      SKIP = .TRUE.
      IERR = 0
      IF ( (A.LT.X(1)) .OR. (A.GT.X(N)) )  IERR = IERR + 1
      IF ( (B.LT.X(1)) .OR. (B.GT.X(N)) )  IERR = IERR + 2
C
C  COMPUTE INTEGRAL VALUE.
C
      IF (A .EQ. B)  THEN
         VALUE = ZERO
      ELSE
         XA = DMIN1 (A, B)
         XB = DMAX1 (A, B)
         IF (XB .LE. X(2))  THEN
C           INTERVAL IS TO LEFT OF X(2), SO USE FIRST CUBIC.
C                   --------------------------------------------
            VALUE = DCHFIV (X(1),X(2), F(1,1),F(1,2),
     *                                D(1,1),D(1,2), A, B, IERV)
C                   --------------------------------------------
            IF (IERV .LT. 0)  GO TO 5004
         ELSE IF (XA .GE. X(N-1))  THEN
C           INTERVAL IS TO RIGHT OF X(N-1), SO USE LAST CUBIC.
C                   -----------------------------------------------
            VALUE = DCHFIV(X(N-1),X(N), F(1,N-1),F(1,N),
     *                                 D(1,N-1),D(1,N), A, B, IERV)
C                   -----------------------------------------------
            IF (IERV .LT. 0)  GO TO 5004
         ELSE
C           "NORMAL" CASE -- XA.LT.XB, XA.LT.X(N-1), XB.GT.X(2).
C      ......LOCATE IA AND IB SUCH THAT
C               X(IA-1).LT.XA.LE.X(IA).LE.X(IB).LE.XB.LE.X(IB+1)
            IA = 1
            NM1=N-1
            DO 10  I = 1, NM1
               IF (XA .GT. X(I))  IA = I + 1
   10       CONTINUE
C             IA = 1 IMPLIES XA.LT.X(1) .  OTHERWISE,
C             IA IS LARGEST INDEX SUCH THAT X(IA-1).LT.XA,.
C
            IB = N
C           DO 20  I = N, IA, -1
C              IF (XB .LT. X(I))  IB = I - 1
C  20       CONTINUE
            NNN=N-IA+1
            DO 20  I = 1, NNN
            ICO=N-I+1
               IF (XB .LT. X(ICO))  IB = ICO - 1
   20       CONTINUE
C             IB = N IMPLIES XB.GT.X(N) .  OTHERWISE,
C             IB IS SMALLEST INDEX SUCH THAT XB.LT.X(IB+1) .
C
C     ......COMPUTE THE INTEGRAL.
            IERV = 0
            IF (IB .LT. IA)  THEN
C              THIS MEANS IB = IA-1 AND
C                 @A,B@ IS A SUBSET OF @X(IB),X(IA)@.
C                      ------------------------------------------------
               VALUE = DCHFIV (X(IB),X(IA), F(1,IB),F(1,IA),
     *                                     D(1,IB),D(1,IA), A, B, IERV)
C                      ------------------------------------------------
               IF (IERV .LT. 0)  GO TO 5004
            ELSE
C
C              FIRST COMPUTE INTEGRAL OVER @X(IA),X(IB)@.
               IF (IB .EQ. IA)  THEN
                  VALUE = ZERO
               ELSE
C                         ---------------------------------------------
                  VALUE = DPCHID (N, X, F, D, INCFD, SKIP, IA, IB, IERD)
C                         ---------------------------------------------
                  IF (IERD .LT. 0)  GO TO 5005
               ENDIF
C
C              THEN ADD ON INTEGRAL OVER @XA,X(IA)@.
               IF (XA .LT. X(IA))  THEN
                  IL = MAX0 (1, IA-1)
                  IR = IL + 1
C                                 -------------------------------------
                  VALUE = VALUE + DCHFIV (X(IL),X(IR), F(1,IL),F(1,IR),
     *                                D(1,IL),D(1,IR), XA, X(IA), IERV)
C                                 -------------------------------------
                  IF (IERV .LT. 0)  GO TO 5004
               ENDIF
C
C              THEN ADD ON INTEGRAL OVER @X(IB),XB@.
               IF (XB .GT. X(IB))  THEN
                  IR = MIN0 (IB+1, N)
                  IL = IR - 1
C                                 -------------------------------------
                  VALUE = VALUE + DCHFIV (X(IL),X(IR), F(1,IL),F(1,IR),
     *                                D(1,IL),D(1,IR), X(IB), XB, IERV)
C                                 -------------------------------------
                  IF (IERV .LT. 0)  GO TO 5004
               ENDIF
C
C              FINALLY, ADJUST SIGN IF NECESSARY.
               IF (A .GT. B)  VALUE = -VALUE
            ENDIF
         ENDIF
      ENDIF
C
C  NORMAL RETURN.
C
      DPCHIA = VALUE
      RETURN
C
C  ERROR RETURNS.
C
 5001 CONTINUE
C     N.LT.2 RETURN.
      IERR = -1
      RETURN
C
 5002 CONTINUE
C     INCFD.LT.1 RETURN.
      IERR = -2
      RETURN
C
 5003 CONTINUE
C     X-ARRAY NOT STRICTLY INCREASING.
      IERR = -3
      RETURN
C
 5004 CONTINUE
C     TROUBLE IN DCHFIV.  (SHOULD NEVER OCCUR.)
      IERR = -4
      RETURN
C
 5005 CONTINUE
C     TROUBLE IN DPCHID.  (SHOULD NEVER OCCUR.)
      IERR = -5
      RETURN
C------------- LAST LINE OF PCHIA FOLLOWS ------------------------------
      END
      DOUBLE PRECISION FUNCTION DCHFIV (X1,X2,F1,F2,D1,D2,A,B,IERR)
      INTEGER  IERR
      DOUBLE PRECISION  X1, X2, F1, F2, D1, D2, A, B
C
C-----------------------------------------------------------------------
C
C          DCHFIV:  CUBIC HERMITE FUNCTION INTEGRAL EVALUATOR.
C
C     CALLED BY  PCHIA  TO EVALUATE THE INTEGRAL OF A SINGLE CUBIC (IN
C     HERMITE FORM) OVER AN ARBITRARY INTERVAL (A,B).
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C            VALUE = DCHFIV (X1, X2, F1, F2, D1, D2, A, B, IERR)
C
C   PARAMETERS:
C
C     VALUE -- (OUTPUT) VALUE OF THE REQUESTED INTEGRAL.
C
C     X1,X2 -- (INPUT) ENDPOINTS IF INTERVAL OF DEFINITION OF CUBIC.
C           (MUST BE DISTINCT.  ERROR RETURN IF NOT.)
C
C     F1,F2 -- (INPUT) FUNCTION VALUES AT THE ENDS OF THE INTERVAL.
C
C     D1,D2 -- (INPUT) DERIVATIVE VALUES AT THE ENDS OF THE INTERVAL.
C
C     A,B -- (INPUT) ENDPOINTS OF INTERVAL OF INTEGRATION.
C
C     IERR -- (OUTPUT) ERROR FLAG.
C           NORMAL RETURN:
C              IERR = 0 (NO ERRORS).
C           "RECOVERABLE ERRORS":
C              IERR = -1  IF X1.EQ.X2 .
C                (VALUE HAS NOT BEEN SET IN THIS CASE.)
C
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-03   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE DCHFIV TO DCHFIV WHEREVER IT OCCURS,
C        B. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION, AND
C        C. CHANGE THE CONSTANTS HALF, TWO, ... TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      DOUBLE PRECISION  DTERM, FOUR, FTERM, H,
     *       HALF, PHIA1, PHIA2, PHIB1, PHIB2,
     *      PSIA1, PSIA2, PSIB1, PSIB2, TA1, TA2, TB1, TB2, THREE, TWO,
     *      UA1, UA2, UB1, UB2 ,SIX
C
C  INITIALIZE.
C
      DATA  HALF /0.5D0/,TWO /2.D0/,THREE /3.D0/,FOUR /4.D0/,SIX /6.D0/
C
C  VALIDITY CHECK INPUT.
C
      IF (X1 .EQ. X2)  GO TO 5001
      IERR = 0
C
C  COMPUTE INTEGRAL.
C
      H = X2 - X1
      TA1 = (A - X1) / H
      TA2 = (X2 - A) / H
      TB1 = (B - X1) / H
      TB2 = (X2 - B) / H
C
      UA1 = TA1**3
      PHIA1 = UA1 * (TWO - TA1)
      PSIA1 = UA1 * (THREE*TA1 - FOUR)
      UA2 = TA2**3
      PHIA2 =  UA2 * (TWO - TA2)
      PSIA2 = -UA2 * (THREE*TA2 - FOUR)
C
      UB1 = TB1**3
      PHIB1 = UB1 * (TWO - TB1)
      PSIB1 = UB1 * (THREE*TB1 - FOUR)
      UB2 = TB2**3
      PHIB2 =  UB2 * (TWO - TB2)
      PSIB2 = -UB2 * (THREE*TB2 - FOUR)
C
      FTERM =   F1*(PHIA2 - PHIB2) + F2*(PHIB1 - PHIA1)
      DTERM = ( D1*(PSIA2 - PSIB2) + D2*(PSIB1 - PSIA1) )*(H/SIX)
C
C  RETURN VALUE.
C
      DCHFIV = (HALF*H) * (FTERM + DTERM)
      RETURN
C
C  ERROR RETURN.
C
 5001 CONTINUE
      IERR = -1
      RETURN
C------------- LAST LINE OF DCHFIV FOLLOWS -----------------------------
      END
      DOUBLE PRECISION
     1       FUNCTION DPCHID (N, X, F, D, INCFD, SKIP, IA, IB, IERR)
C
C-----------------------------------------------------------------------
C
C          PCHID:  PIECEWISE CUBIC HERMITE INTEGRATOR, DATA LIMITS
C
C     EVALUATES THE DEFINITE INTEGRAL OF THE CUBIC HERMITE FUNCTION
C     DEFINED BY  N, X, F, D  OVER THE INTERVAL @X(IA), X(IB)@.
C
C     TO PROVIDE COMPATIBILITY WITH PCHIM AND PCHIC, INCLUDES AN
C     INCREMENT BETWEEN SUCCESSIVE VALUES OF THE F- AND D-ARRAYS.
C
C-----------------------------------------------------------------------
C
C  CALLING SEQUENCE:
C
C           VALUE = PCHID (N, X, F, D, INCFD, SKIP, IA, IB, IERR)
C
      INTEGER  N, INCFD, IA, IB, IERR
      DOUBLE PRECISION  X(N), F(INCFD,N), D(INCFD,N)
      LOGICAL  SKIP
C
C   PARAMETERS:
C
C     VALUE -- (OUTPUT) VALUE OF THE REQUESTED INTEGRAL.
C
C     N -- (INPUT) NUMBER OF DATA POINTS.  (ERROR RETURN IF N.LT.2 .)
C
C     X -- (INPUT) REAL ARRAY OF INDEPENDENT VARIABLE VALUES.  THE
C           ELEMENTS OF X MUST BE STRICTLY INCREASING:
C                X(I-1) .LT. X(I),  I = 2(1)N.
C           (ERROR RETURN IF NOT.)
C
C     F -- (INPUT) REAL ARRAY OF FUNCTION VALUES.  F(1+(I-1)*INCFD) IS
C           THE VALUE CORRESPONDING TO X(I).
C
C     D -- (INPUT) REAL ARRAY OF DERIVATIVE VALUES.  D(1+(I-1)*INCFD) IS
C           THE VALUE CORRESPONDING TO X(I).
C
C     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN F AND D.
C           (ERROR RETURN IF  INCFD.LT.1 .)
C
C     SKIP -- (INPUT/OUTPUT) LOGICAL VARIABLE WHICH SHOULD BE SET TO
C           .TRUE. IF THE USER WISHES TO SKIP CHECKS FOR VALIDITY OF
C           PRECEDING PARAMETERS, OR TO .FALSE. OTHERWISE.
C           THIS WILL SAVE TIME IN CASE THESE CHECKS HAVE ALREADY
C           BEEN PERFORMED (SAY, IN PCHIM OR PCHIC).
C           SKIP WILL BE SET TO .TRUE. ON RETURN WITH IERR = 0 OR -4.
C
C     IA,IB -- (INPUT) INDICES IN X-ARRAY FOR THE LIMITS OF INTEGRATION.
C           BOTH MUST BE IN THE RANGE @1,N@.  (ERROR RETURN IF NOT.)
C           NO RESTRICTIONS ON THEIR RELATIVE VALUES.
C
C     IERR -- (OUTPUT) ERROR FLAG.
C           NORMAL RETURN:
C              IERR = 0  (NO ERRORS).
C           "RECOVERABLE" ERRORS:
C              IERR = -1  IF N.LT.2 .
C              IERR = -2  IF INCFD.LT.1 .
C              IERR = -3  IF THE X-ARRAY IS NOT STRICTLY INCREASING.
C              IERR = -4  IF IA OR IB IS OUT OF RANGE.
C                (VALUE HAS NOT BEEN COMPUTED IN ANY OF THESE CASES.)
C               NOTE:  THE ABOVE ERRORS ARE CHECKED IN THE ORDER LISTED,
C                   AND FOLLOWING ARGUMENTS HAVE **NOT** BEEN VALIDATED.
C
C
C  FORTRAN INTRINSICS USED:  MAX0, MIN0.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
C                  MATHEMATICS AND STATISTICS DIVISION,
C                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
C
C  CHANGE RECORD:
C     82-08-03   MINOR COSMETIC CHANGES FOR RELEASE 1.
C
C-----------------------------------------------------------------------
C
C  PROGRAMMING NOTES.
C
C     TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
C        A. CHANGE PCHID TO DPCHID WHEREVER IT OCCURS,
C        B. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION,  AND
C        C. CHANGE THE CONSTANTS ZERO, HALF, SIX TO DOUBLE PRECISION.
C
C-----------------------------------------------------------------------
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I, IUP, LOW
      DOUBLE PRECISION  H, HALF, SIX, SUM, VALUE, ZERO
C
C  INITIALIZE.
C
      DATA  ZERO /0.D0/,  HALF /0.5D0/,  SIX /6.D0/
C
C  VALIDITY-CHECK ARGUMENTS.
C
      IF (SKIP)  GO TO 5
C
      IF ( N.LT.2 )  GO TO 5001
      IF ( INCFD.LT.1 )  GO TO 5002
      DO 1  I = 2, N
         IF ( X(I).LE.X(I-1) )  GO TO 5003
    1 CONTINUE
C
C  FUNCTION DEFINITION IS OK, GO ON.
C
    5 CONTINUE
      SKIP = .TRUE.
      IF ((IA.LT.1) .OR. (IA.GT.N))  GO TO 5004
      IF ((IB.LT.1) .OR. (IB.GT.N))  GO TO 5004
      IERR = 0
C
C  COMPUTE INTEGRAL VALUE.
C
      IF (IA .EQ. IB)  THEN
         VALUE = ZERO
      ELSE
         LOW = MIN0(IA, IB)
         IUP = MAX0(IA, IB) - 1
         SUM = ZERO
         DO 10  I = LOW, IUP
            H = X(I+1) - X(I)
            SUM = SUM + H*( (F(1,I) + F(1,I+1)) +
     *                      (D(1,I) - D(1,I+1))*(H/SIX) )
   10    CONTINUE
         VALUE = HALF * SUM
         IF (IA .GT. IB)  VALUE = -VALUE
      ENDIF
C
C  NORMAL RETURN.
C
      DPCHID = VALUE
      RETURN
C
C  ERROR RETURNS.
C
 5001 CONTINUE
C     N.LT.2 RETURN.
      IERR = -1
      RETURN
C
 5002 CONTINUE
C     INCFD.LT.1 RETURN.
      IERR = -2
      RETURN
C
 5003 CONTINUE
C     X-ARRAY NOT STRICTLY INCREASING.
      IERR = -3
      RETURN
C
 5004 CONTINUE
C     IA OR IB OUT OF RANGE RETURN.
      IERR = -4
      RETURN
C------------- LAST LINE OF DPCHID FOLLOWS -----------------------------
      END
      subroutine  dpchim (n, x, f, d, incfd, ierr)
c 
c-----------------------------------------------------------------------
c 
c          PCHIM:  PIECEWISE CUBIC HERMITE INTERPOLATION TO
c                  MONOTONE DATA.
c 
c     SETS DERIVATIVES NEEDED TO DETERMINE A MONOTONE PIECEWISE CUBIC
c     HERMITE INTERPOLANT TO THE DATA GIVEN IN X AND F.
c 
c     DEFAULT BOUNDARY CONDITIONS ARE PROVIDED WHICH ARE COMPATIBLE
c     WITH MONOTONICITY.  (SEE PCHIC IF USER CONTROL OF BOUNDARY CON-
c     DITIONS IS DESIRED.)
c 
c     IF THE DATA ARE ONLY PIECEWISE MONOTONIC, THE INTERPOLANT WILL
c     HAVE AN EXTREMUM AT EACH POINT WHERE MONOTONICITY SWITCHES DIREC-
c     TION.  (SEE PCHIC IF USER CONTROL IS DESIRED IN SUCH CASES.)
c 
c     TO FACILITATE TWO-DIMENSIONAL APPLICATIONS, INCLUDES AN INCREMENT
c     BETWEEN SUCCESSIVE VALUES OF THE F- AND D-ARRAYS.
c 
c     THE RESULTING PIECEWISE CUBIC HERMITE FUNCTION MAY BE EVALUATED
c     BY PCHFE OR PCHFD.
c 
c-----------------------------------------------------------------------
c 
c  CALLING SEQUENCE:
c 
c           CALL  PCHIM (N, X, F, D, INCFD, IERR)
c 
      integer  n, incfd, ierr
      double precision  x(n), f(incfd,n), d(incfd,n)
c 
c   PARAMETERS:
c 
c     N -- (INPUT) NUMBER OF DATA POINTS.  (ERROR RETURN IF N.LT.2 .)
c           IF N=2, SIMPLY DOES LINEAR INTERPOLATION.
c 
c     X -- (INPUT) REAL ARRAY OF INDEPENDENT VARIABLE VALUES.  THE
c           ELEMENTS OF X MUST BE STRICTLY INCREASING:
c                X(I-1) .LT. X(I),  I = 2(1)N.
c           (ERROR RETURN IF NOT.)
c 
c     F -- (INPUT) REAL ARRAY OF DEPENDENT VARIABLE VALUES TO BE INTER-
c           POLATED.  F(1+(I-1)*INCFD) IS VALUE CORRESPONDING TO X(I).
c           PCHIM IS DESIGNED FOR MONOTONIC DATA, BUT IT WILL WORK FOR
c           ANY F-ARRAY.  IT WILL FORCE EXTREMA AT POINTS WHERE MONO-
c           TONICITY SWITCHES DIRECTION.  IF SOME OTHER TREATMENT OF
c           SWITCH POINTS IS DESIRED, PCHIC SHOULD BE USED INSTEAD.
c                                     -----
c 
c     D -- (OUTPUT) REAL ARRAY OF DERIVATIVE VALUES AT THE DATA POINTS.
c           IF THE DATA ARE MONOTONIC, THESE VALUES WILL DETERMINE A
c           A MONOTONE CUBIC HERMITE FUNCTION.
c           THE VALUE CORRESPONDING TO X(I) IS STORED IN
c                D(1+(I-1)*INCFD),  I=1(1)N.
c           NO OTHER ENTRIES IN D ARE CHANGED.
c 
c     INCFD -- (INPUT) INCREMENT BETWEEN SUCCESSIVE VALUES IN F AND D.
c           THIS ARGUMENT IS PROVIDED PRIMARILY FOR 2-D APPLICATIONS.
c           (ERROR RETURN IF  INCFD.LT.1 .)
c 
c     IERR -- (OUTPUT) ERROR FLAG.
c           NORMAL RETURN:
c              IERR = 0  (NO ERRORS).
c           WARNING ERROR:
c              IERR.GT.0  MEANS THAT IERR SWITCHES IN THE DIRECTION
c                 OF MONOTONICITY WERE DETECTED.
c           "RECOVERABLE" ERRORS:
c              IERR = -1  IF N.LT.2 .
c              IERR = -2  IF INCFD.LT.1 .
c              IERR = -3  IF THE X-ARRAY IS NOT STRICTLY INCREASING.
c             (THE D-ARRAY HAS NOT BEEN CHANGED IN ANY OF THESE CASES.)
c               NOTE:  THE ABOVE ERRORS ARE CHECKED IN THE ORDER LISTED,
c                   AND FOLLOWING ARGUMENTS HAVE **NOT** BEEN VALIDATED.
c 
c  FORTRAN INTRINSICS USED:  ABS, AMAX1, AMIN1.
c  OTHER ROUTINES USED:  PCHST.
c 
c-----------------------------------------------------------------------
c 
c  REFERENCES:  1. F.N.FRITSCH AND R.E.CARLSON, "MONOTONE PIECEWISE
c                 CUBIC INTERPOLATION," SIAM J.NUMER.ANAL. 17, 2 (APRIL
c                 1980), 238-246.
c               2. F.N.FRITSCH AND J.BUTLAND, "A METHOD FOR CONSTRUCTING
c                 LOCAL MONOTONE PIECEWISE CUBIC INTERPOLANTS," LLNL
c                 PREPRINT UCRL-87559 (APRIL 1982).
c 
c-----------------------------------------------------------------------
c 
c  PROGRAMMED BY:  FRED N. FRITSCH,  FTS 532-4275,
c                  MATHEMATICS AND STATISTICS DIVISION,
c                  LAWRENCE LIVERMORE NATIONAL LABORATORY.
c 
c  CHANGE RECORD:
c     82-02-01   1. INTRODUCED  PCHST  TO REDUCE POSSIBLE OVER/UNDER-
c                   FLOW PROBLEMS.
c                2. REARRANGED DERIVATIVE FORMULA FOR SAME REASON.
c     82-06-02   1. MODIFIED END CONDITIONS TO BE CONTINUOUS FUNCTIONS
c                   OF DATA WHEN MONOTONICITY SWITCHES IN NEXT INTERVAL.
c                2. MODIFIED FORMULAS SO END CONDITIONS ARE LESS PRONE
c                   OF OVER/UNDERFLOW PROBLEMS.
c     82-08-03   MINOR COSMETIC CHANGES FOR RELEASE 1.
c 
c-----------------------------------------------------------------------
c 
c  PROGRAMMING NOTES.
c 
c     1. THE FUNCTION  PCHST(ARG1,ARG2)  IS ASSUMED TO RETURN ZERO IF
c        EITHER ARGUMENT IS ZERO, +1 IF THEY ARE OF THE SAME SIGN, AND
c        -1 IF THEY ARE OF OPPOSITE SIGN.
c     2. TO PRODUCE A DOUBLE PRECISION VERSION, SIMPLY:
c        A. CHANGE PCHIM TO DPCHIM WHEREVER IT OCCURS,
c        B. CHANGE PCHST TO DPCHST WHEREVER IT OCCURS,
c        C. CHANGE ALL REFERENCES TO THE FORTRAN INTRINSICS TO THEIR
c           DOUBLE PRECISION EQUIVALENTS,
c        D. CHANGE THE REAL DECLARATIONS TO DOUBLE PRECISION, AND
c        E. CHANGE THE CONSTANTS ZERO AND THREE TO DOUBLE PRECISION.
c 
c-----------------------------------------------------------------------
c 
c  DECLARE LOCAL VARIABLES.
c 
      integer  i, nless1
      double precision  del1, del2, dmax, dmin, drat1, drat2, dsave,
     *      h1, h2, hsum, hsumt3, three, w1, w2, zero
      double precision  dpchst
      data  zero /0.d0/,  three /3.d0/
c 
c  VALIDITY-CHECK ARGUMENTS.
c 
      if ( n.lt.2 )  go to 5001
      if ( incfd.lt.1 )  go to 5002
      do 1  i = 2, n
         if ( x(i).le.x(i-1) )  go to 5003
    1 continue
c 
c  FUNCTION DEFINITION IS OK, GO ON.
c 
      ierr = 0
      nless1 = n - 1
      h1 = x(2) - x(1)
      del1 = (f(1,2) - f(1,1))/h1
      dsave = del1
c 
c  SPECIAL CASE N=2 -- USE LINEAR INTERPOLATION.
c 
      if (nless1 .gt. 1)  go to 10
      d(1,1) = del1
      d(1,n) = del1
      go to 5000
c 
c  NORMAL CASE  (N .GE. 3).
c 
   10 continue
      h2 = x(3) - x(2)
      del2 = (f(1,3) - f(1,2))/h2
c 
c  SET D(1) VIA NON-CENTERED THREE-POINT FORMULA, ADJUSTED TO BE
c     SHAPE-PRESERVING.
c 
      hsum = h1 + h2
      w1 = (h1 + hsum)/hsum
      w2 = -h1/hsum
      d(1,1) = w1*del1 + w2*del2
      if (dpchst(d(1,1),del1) .le. zero)  then
         d(1,1) = zero
      else if (dpchst(del1,del2) .lt. zero)  then
c        NEED DO THIS CHECK ONLY IF MONOTONICITY SWITCHES.
         dmax = three*del1
         if (dabs(d(1,1)) .gt. dabs(dmax))  d(1,1) = dmax
      endif
c 
c  LOOP THROUGH INTERIOR POINTS.
c 
      do 50  i = 2, nless1
         if (i .eq. 2)  go to 40
c 
         h1 = h2
         h2 = x(i+1) - x(i)
         hsum = h1 + h2
         del1 = del2
         del2 = (f(1,i+1) - f(1,i))/h2
   40    continue
c 
c        SET D(I)=0 UNLESS DATA ARE STRICTLY MONOTONIC.
c 
         d(1,i) = zero
         if (dpchst(del1,del2) )  42, 41, 45
c 
c        COUNT NUMBER OF CHANGES IN DIRECTION OF MONOTONICITY.
c 
   41    continue
         if (del2 .eq. zero)  go to 50
         if (dpchst(dsave,del2) .lt. zero)  ierr = ierr + 1
         dsave = del2
         go to 50
c 
   42    continue
         ierr = ierr + 1
         dsave = del2
         go to 50
c 
c        USE BRODLIE MODIFICATION OF BUTLAND FORMULA.
c 
   45    continue
         hsumt3 = hsum+hsum+hsum
         w1 = (hsum + h1)/hsumt3
         w2 = (hsum + h2)/hsumt3
         dmax = dmax1( dabs(del1), dabs(del2) )
         dmin = dmin1( dabs(del1), dabs(del2) )
         drat1 = del1/dmax
         drat2 = del2/dmax
         d(1,i) = dmin/(w1*drat1 + w2*drat2)
c 
   50 continue
c 
c  SET D(N) VIA NON-CENTERED THREE-POINT FORMULA, ADJUSTED TO BE
c     SHAPE-PRESERVING.
c 
      w1 = -h2/hsum
      w2 = (h2 + hsum)/hsum
      d(1,n) = w1*del1 + w2*del2
      if (dpchst(d(1,n),del2) .le. zero)  then
         d(1,n) = zero
      else if (dpchst(del1,del2) .lt. zero)  then
c        NEED DO THIS CHECK ONLY IF MONOTONICITY SWITCHES.
         dmax = three*del2
         if (dabs(d(1,n)) .gt. dabs(dmax))  d(1,n) = dmax
      endif
c 
c  NORMAL RETURN.
c 
 5000 continue
      return
c 
c  ERROR RETURNS.
c 
 5001 continue
c     N.LT.2 RETURN.
      ierr = -1
      return
c 
 5002 continue
c     INCFD.LT.1 RETURN.
      ierr = -2
      return
c 
 5003 continue
c     X-ARRAY NOT STRICTLY INCREASING.
      ierr = -3
      return
c------------- LAST LINE OF PCHIM FOLLOWS ------------------------------
      end
